#include <tavr_runtime.h>
struct Engine {
	void * __tavr_out_mouse;
	void * __tavr_out_resize;
	void * __tavr_out_update;
	__tavr_int MOUSE_ACTION_DOWN;
	__tavr_int MOUSE_ACTION_UP;
	__tavr_int MOUSE_ACTION_MOVE;
	__tavr_int MOUSE_BUTTON_LEFT;
	__tavr_int MOUSE_BUTTON_RIGHT;
	__tavr_int MOUSE_BUTTON_MIDDLE;
	__tavr_double timer;
	__tavr_float fps;
	__tavr_int fpsCounter;
	__tavr_float fpsTimer;
	__tavr_int implData;
};
void __tavr__Engine___destr_Engine(struct __tavr_ref_Engine* __tavr_this);
struct __tavr_ref_Engine {
	__tavr_int* ref;
	struct Engine* ptr;
};
void * __tavr_ti_Engine[];
struct EngShader {
	__tavr_int implData;
};
void __tavr__EngShader___destr_EngShader(struct __tavr_ref_EngShader* __tavr_this);
struct __tavr_ref_EngShader {
	__tavr_int* ref;
	struct EngShader* ptr;
};
void * __tavr_ti_EngShader[];
struct EngV2 {
	__tavr_float x;
	__tavr_float y;
};
struct __tavr_array_GameBall {
	__tavr_int* ref;
	struct __tavr_ref_GameBall* ptr;
};
struct EngColor {
	__tavr_float r;
	__tavr_float g;
	__tavr_float b;
	__tavr_float a;
};
struct GameBall {
	__tavr_int __tavr_relax_0;
	__tavr_byte __tavr_stack_0[88];
	struct EngV2 pos;
	struct EngV2 speed;
	__tavr_float radius;
	struct EngColor color;
};
void __tavr__GameBall___destr_GameBall(struct __tavr_ref_GameBall* __tavr_this);
struct __tavr_ref_GameBall {
	__tavr_int* ref;
	struct GameBall* ptr;
};
void * __tavr_ti_GameBall[];
void * __tavr_ti_GameBall_a[];
struct Game {
	__tavr_int __tavr_relax;
	void * __tavr_out_render;
	void * __tavr_out_update;
	struct __tavr_ref_Engine engine;
	struct __tavr_ref_EngShader shaderCircle;
	struct __tavr_ref_EngShader shaderTransform;
	__tavr_float windowWidth;
	__tavr_float windowHeight;
	__tavr_float width;
	__tavr_float height;
	struct EngV2 wnd2scr;
	struct EngV2 defGravityCenter;
	struct EngV2 gravityCenter;
	__tavr_bool gravityEnable;
	__tavr_float gravityCoef;
	__tavr_float maxSpeed;
	__tavr_float maxAcceler;
	__tavr_float massCoef;
	__tavr_float rigidCoef;
	__tavr_float mergeBarrier;
	__tavr_float ballRadius;
	__tavr_float ballRadiusRangeCoef;
	__tavr_float explodeBarrier;
	__tavr_float timeFactor;
	__tavr_float changeGravTimeCoef;
	__tavr_float changeSingleGravTimeCoef;
	__tavr_int explodeBallsCount;
	__tavr_float explodeSpeed;
	__tavr_int ballsCountMax;
	__tavr_int ballsCount;
	struct __tavr_array_GameBall balls;
};
struct __tavr_ref_Game {
	__tavr_int* ref;
	struct Game* ptr;
};
void * __tavr_ti_Game[];
void __tavr__Game___destr_Game(struct __tavr_ref_Game* __tavr_this);
void __tavr__Game___Game(struct __tavr_ref_Game* __tavr_this);
void __tavr__Game___run(struct __tavr_ref_Game* __tavr_this);
void __tavr__Game___auto(struct __tavr_ref_Game* __tavr_this);
void __tavr__GameBall___GameBall___Game(struct __tavr_ref_GameBall* __tavr_this, struct __tavr_ref_Game game);
void __tavr__GameBall___auto_0(struct __tavr_ref_GameBall* __tavr_this);
void __tavr__GameBall___auto_1(struct __tavr_ref_GameBall* __tavr_this);
struct EngUpdate {
	__tavr_float time;
};
void __tavr__EngUpdate___destr_EngUpdate(struct __tavr_ref_EngUpdate* __tavr_this);
struct __tavr_ref_EngUpdate {
	__tavr_int* ref;
	struct EngUpdate* ptr;
};
void * __tavr_ti_EngUpdate[];
struct GameUpdate {
	__tavr_float elapsedTime;
	struct __tavr_ref_Game game;
};
struct __tavr_ref_GameUpdate {
	__tavr_int* ref;
	struct GameUpdate* ptr;
};
void * __tavr_ti_GameUpdate[];
void __tavr__GameUpdate___destr_GameUpdate(struct __tavr_ref_GameUpdate* __tavr_this);
void __tavr__GameUpdate___GameUpdate___float___Game(struct __tavr_ref_GameUpdate* __tavr_this, __tavr_float elapsedTime, struct __tavr_ref_Game game);
void __tavr__Engine___beginScene(struct __tavr_ref_Engine* __tavr_this);
void __tavr__EngColor___EngColor___float___float___float(struct EngColor* __tavr_this, __tavr_float r, __tavr_float g, __tavr_float b);
void __tavr__Engine___clear___EngColor_r(struct __tavr_ref_Engine* __tavr_this, struct EngColor* color);
struct GameRender {
	struct __tavr_ref_Game game;
};
struct __tavr_ref_GameRender {
	__tavr_int* ref;
	struct GameRender* ptr;
};
void * __tavr_ti_GameRender[];
void __tavr__GameRender___destr_GameRender(struct __tavr_ref_GameRender* __tavr_this);
void __tavr__GameRender___GameRender___Game(struct __tavr_ref_GameRender* __tavr_this, struct __tavr_ref_Game game);
void __tavr__Engine___endScene(struct __tavr_ref_Engine* __tavr_this);
struct EngResize {
	__tavr_float width;
	__tavr_float height;
	__tavr_bool isReset;
};
void __tavr__EngResize___destr_EngResize(struct __tavr_ref_EngResize* __tavr_this);
struct __tavr_ref_EngResize {
	__tavr_int* ref;
	struct EngResize* ptr;
};
void * __tavr_ti_EngResize[];
void __tavr__EngV2___EngV2___float___float(struct EngV2* __tavr_this, __tavr_float x, __tavr_float y);
void __tavr__EngShader___release(struct __tavr_ref_EngShader* __tavr_this);
struct string {
	__tavr_int length;
};
struct __tavr_ref_string {
	__tavr_int* ref;
	struct string* ptr;
};
void * __tavr_ti_string[];
void __tavr__string___destr_string(struct __tavr_ref_string* __tavr_this);
struct __tavr_ref_EngShader __tavr__Engine___loadPixelShader___string(struct __tavr_ref_Engine* __tavr_this, struct __tavr_ref_string path);
struct __tavr_ref_EngShader __tavr__Engine___loadVertexShader___string(struct __tavr_ref_Engine* __tavr_this, struct __tavr_ref_string path);
void __tavr__EngShader___set___string___float(struct __tavr_ref_EngShader* __tavr_this, struct __tavr_ref_string name, __tavr_float v);
void __tavr__Engine___run(struct __tavr_ref_Engine* __tavr_this);
void __tavr__Engine___release(struct __tavr_ref_Engine* __tavr_this);
void __tavr__EngV2___EngV2(struct EngV2* __tavr_this);
void __tavr__Engine___Engine___string___int___int(struct __tavr_ref_Engine* __tavr_this, struct __tavr_ref_string name, __tavr_int width, __tavr_int height);
struct GameController {
	__tavr_int __tavr_relax;
	__tavr_byte __tavr_stack[24];
	struct __tavr_ref_Game game;
	__tavr_float clickTimer;
	__tavr_float doubleClickTimer;
	__tavr_float lastClick;
	__tavr_float lastDown;
};
struct __tavr_ref_GameController {
	__tavr_int* ref;
	struct GameController* ptr;
};
void * __tavr_ti_GameController[];
void __tavr__GameController___destr_GameController(struct __tavr_ref_GameController* __tavr_this);
void __tavr__GameController___GameController___Game(struct __tavr_ref_GameController* __tavr_this, struct __tavr_ref_Game game);
void __tavr__GameController___auto(struct __tavr_ref_GameController* __tavr_this);
struct __tavr_array_string {
	__tavr_int* ref;
	struct __tavr_ref_string* ptr;
};
void * __tavr_ti_string_a[];
__tavr_int __tavr__main___string_a(struct __tavr_array_string __tavr_dummy_arg_0)
{
	struct __tavr_ref_Game __tavr_tmp_0;
	__tavr_tmp_0.ref = __tavr_alloc(149, __tavr_ti_Game);
	__tavr_tmp_0.ptr = (void*)(__tavr_tmp_0.ref+2);
	__tavr__Game___Game(&__tavr_tmp_0);
	__tavr__Game___run(&__tavr_tmp_0);
	__TAVR_DEC_REF(__tavr_tmp_0);
	__TAVR_DEC_REF(__tavr_dummy_arg_0);
	return 0;
	__TAVR_DEC_REF(__tavr_dummy_arg_0);
}
void __tavr__Game___auto(struct __tavr_ref_Game* __tavr_this)
{
	switch (__tavr_this->ptr->__tavr_relax) {
		__TAVR_RELAX_CASE_DEFAULT2();
		__TAVR_RELAX_CASE2(1, __tavr_label_2);
		default: __TAVR_UNKNOWN_RELAX_CONTEXT(); return ;
	}
	{
		{
			struct __tavr_ref_Game __tavr_tmp_1;
			struct __tavr_ref_Game __tavr_tmp_2;
			__tavr_int __tavr_tmp_3;
			struct __tavr_array_GameBall __tavr_tmp_4;
			struct __tavr_array_GameBall* __tavr_tmp_5;
			__tavr_tmp_1 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_1);
			__tavr_tmp_2 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_2);
			__tavr_tmp_3 = __tavr_tmp_2.ptr->ballsCountMax;
			__tavr_tmp_4.ref = __tavr_alloc_array(__tavr_tmp_3, 8, __tavr_ti_GameBall_a);
			__tavr_tmp_4.ptr = (void*)(__tavr_tmp_4.ref+3);
			memset(__tavr_tmp_4.ptr, 0, 8*__tavr_tmp_3);
			__tavr_tmp_5 = &__tavr_tmp_1.ptr->balls;
			__TAVR_DEC_REF((*__tavr_tmp_5));
			(*__tavr_tmp_5) = __tavr_tmp_4;
			__TAVR_INC_REF((*__tavr_tmp_5));
			__TAVR_DEC_REF(__tavr_tmp_4);
			{
				__tavr_int i;
				__tavr_bool __tavr_tmp_6;
				i = 0;
__tavr_label_0: ;
				__tavr_tmp_1 = (*__tavr_this);
				__TAVR_ASSERT_NULL_PTR(__tavr_tmp_1);
				__tavr_tmp_6 = (i < __tavr_tmp_1.ptr->ballsCountMax);
				if(__tavr_tmp_6)
				{
					struct __tavr_ref_GameBall __tavr_tmp_7;
					struct __tavr_ref_GameBall* __tavr_tmp_8;
					__tavr_tmp_1 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_1);
					__tavr_tmp_4 = __tavr_tmp_1.ptr->balls;
					__tavr_tmp_3 = i;
					__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_4, __tavr_tmp_3);
					__tavr_tmp_2 = (*__tavr_this);
					__TAVR_INC_REF(__tavr_tmp_2);
					__tavr_tmp_7.ref = __tavr_alloc(128, __tavr_ti_GameBall);
					__tavr_tmp_7.ptr = (void*)(__tavr_tmp_7.ref+2);
					__tavr__GameBall___GameBall___Game(&__tavr_tmp_7, __tavr_tmp_2);
					__tavr_tmp_8 = &__tavr_tmp_4.ptr[__tavr_tmp_3];
					__TAVR_DEC_REF((*__tavr_tmp_8));
					(*__tavr_tmp_8) = __tavr_tmp_7;
					__TAVR_INC_REF((*__tavr_tmp_8));
					__TAVR_DEC_REF(__tavr_tmp_7);
					__tavr_tmp_1 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_1);
					__tavr_tmp_4 = __tavr_tmp_1.ptr->balls;
					__tavr_tmp_3 = i;
					__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_4, __tavr_tmp_3);
					__TAVR_INC_REF(__tavr_tmp_4.ptr[__tavr_tmp_3]);
					__tavr_add_out_list(&(*__tavr_this).ptr->__tavr_out_update, *(__tavr_ref_t*)&__tavr_tmp_4.ptr[__tavr_tmp_3], (__tavr_auto_proc_t)__tavr__GameBall___auto_0, 0);
					__tavr_tmp_1 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_1);
					__tavr_tmp_4 = __tavr_tmp_1.ptr->balls;
					__tavr_tmp_3 = i;
					__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_4, __tavr_tmp_3);
					__TAVR_INC_REF(__tavr_tmp_4.ptr[__tavr_tmp_3]);
					__tavr_add_out_list(&(*__tavr_this).ptr->__tavr_out_render, *(__tavr_ref_t*)&__tavr_tmp_4.ptr[__tavr_tmp_3], (__tavr_auto_proc_t)__tavr__GameBall___auto_1, 0);
				}
				else
				goto __tavr_label_1;
				{
					++i;
				}
				goto __tavr_label_0;
__tavr_label_1: ;
			}
			__tavr_tmp_1 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_1);
			__tavr_tmp_2 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_2);
			__tavr_tmp_1.ptr->ballsCount = __tavr_tmp_2.ptr->ballsCountMax;
		}
__tavr_label_2: ;
		{
			if (__tavr_cur_event.ref != 0 && ((int*)__tavr_cur_event.ref[1])[2] == 0)
			{
				struct __tavr_ref_EngUpdate event;
				event = (*(struct __tavr_ref_EngUpdate*)&__tavr_cur_event);
				__TAVR_INC_REF(event);
				__TAVR_DEC_REF((*(struct __tavr_ref_EngUpdate*)&__tavr_cur_event));
				(*(struct __tavr_ref_EngUpdate*)&__tavr_cur_event).ptr = 0;
				(*(struct __tavr_ref_EngUpdate*)&__tavr_cur_event).ref = 0;
				{
					struct __tavr_ref_Game __tavr_tmp_9;
					struct __tavr_ref_EngUpdate __tavr_tmp_10;
					__tavr_float __tavr_tmp_11;
					struct __tavr_ref_Game __tavr_tmp_12;
					struct __tavr_ref_GameUpdate __tavr_tmp_13;
					__tavr_float __tavr_tmp_14;
					__tavr_float __tavr_tmp_15;
					struct EngColor __tavr_tmp_16;
					struct __tavr_ref_GameRender __tavr_tmp_17;
					__tavr_tmp_9 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
					__tavr_tmp_10 = event;
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_10);
					__tavr_tmp_11 = ((__tavr_tmp_9.ptr->timeFactor * __tavr_tmp_10.ptr->time) / 1000.f);
					__tavr_tmp_12 = (*__tavr_this);
					__TAVR_INC_REF(__tavr_tmp_12);
					__tavr_tmp_13.ref = __tavr_alloc(12, __tavr_ti_GameUpdate);
					__tavr_tmp_13.ptr = (void*)(__tavr_tmp_13.ref+2);
					__tavr__GameUpdate___GameUpdate___float___Game(&__tavr_tmp_13, __tavr_tmp_11, __tavr_tmp_12);
					__TAVR_INC_REF(__tavr_tmp_13);
					__tavr_out_call(__tavr_this->ptr->__tavr_out_update, *(__tavr_ref_t*)&__tavr_tmp_13);
					__TAVR_DEC_REF(__tavr_tmp_13);
					__tavr_tmp_9 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
					__tavr__Engine___beginScene(&__tavr_tmp_9.ptr->engine);
					__tavr_tmp_9 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
					__tavr_tmp_11 = 1.f;
					__tavr_tmp_14 = 1.f;
					__tavr_tmp_15 = 1.f;
					__tavr__EngColor___EngColor___float___float___float(&__tavr_tmp_16, __tavr_tmp_11, __tavr_tmp_14, __tavr_tmp_15);
					__tavr__Engine___clear___EngColor_r(&__tavr_tmp_9.ptr->engine, &__tavr_tmp_16);
					__tavr_tmp_9 = (*__tavr_this);
					__TAVR_INC_REF(__tavr_tmp_9);
					__tavr_tmp_17.ref = __tavr_alloc(8, __tavr_ti_GameRender);
					__tavr_tmp_17.ptr = (void*)(__tavr_tmp_17.ref+2);
					__tavr__GameRender___GameRender___Game(&__tavr_tmp_17, __tavr_tmp_9);
					__TAVR_INC_REF(__tavr_tmp_17);
					__tavr_out_call(__tavr_this->ptr->__tavr_out_render, *(__tavr_ref_t*)&__tavr_tmp_17);
					__TAVR_DEC_REF(__tavr_tmp_17);
					__tavr_tmp_9 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
					__tavr__Engine___endScene(&__tavr_tmp_9.ptr->engine);
				}
				__TAVR_DEC_REF(event);
			}
			else
			{
			}
			if (__tavr_cur_event.ref != 0 && ((int*)__tavr_cur_event.ref[1])[2] == 1)
			{
				struct __tavr_ref_EngResize event;
				event = (*(struct __tavr_ref_EngResize*)&__tavr_cur_event);
				__TAVR_INC_REF(event);
				__TAVR_DEC_REF((*(struct __tavr_ref_EngResize*)&__tavr_cur_event));
				(*(struct __tavr_ref_EngResize*)&__tavr_cur_event).ptr = 0;
				(*(struct __tavr_ref_EngResize*)&__tavr_cur_event).ref = 0;
				{
					struct __tavr_ref_Game __tavr_tmp_18;
					struct __tavr_ref_EngResize __tavr_tmp_19;
					struct __tavr_ref_Game __tavr_tmp_20;
					__tavr_bool __tavr_tmp_21;
					struct __tavr_ref_Game __tavr_tmp_26;
					struct __tavr_ref_Game __tavr_tmp_27;
					struct __tavr_ref_Game __tavr_tmp_28;
					__tavr_float __tavr_tmp_29;
					__tavr_float __tavr_tmp_30;
					struct EngV2 __tavr_tmp_31;
					struct EngV2* __tavr_tmp_32;
					struct __tavr_ref_string __tavr_tmp_37;
					struct __tavr_ref_string __tavr_tmp_38;
					__tavr_tmp_18 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
					__tavr_tmp_19 = event;
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_19);
					__tavr_tmp_18.ptr->windowWidth = __tavr_tmp_19.ptr->width;
					__tavr_tmp_18 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
					__tavr_tmp_19 = event;
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_19);
					__tavr_tmp_18.ptr->windowHeight = __tavr_tmp_19.ptr->height;
					__tavr_tmp_18 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
					__tavr_tmp_20 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_20);
					__tavr_tmp_21 = (__tavr_tmp_18.ptr->width > __tavr_tmp_20.ptr->height);
					if(__tavr_tmp_21)
					{
						struct __tavr_ref_Game __tavr_tmp_22;
						struct __tavr_ref_Game __tavr_tmp_23;
						__tavr_tmp_18 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
						__tavr_tmp_20 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_20);
						__tavr_tmp_22 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
						__tavr_tmp_23 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_23);
						__tavr_tmp_18.ptr->width = ((__tavr_tmp_20.ptr->height * __tavr_tmp_22.ptr->windowWidth) / __tavr_tmp_23.ptr->windowHeight);
					}
					else
					{
						struct __tavr_ref_Game __tavr_tmp_24;
						struct __tavr_ref_Game __tavr_tmp_25;
						__tavr_tmp_18 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
						__tavr_tmp_20 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_20);
						__tavr_tmp_24 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_24);
						__tavr_tmp_25 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_25);
						__tavr_tmp_18.ptr->height = ((__tavr_tmp_20.ptr->width * __tavr_tmp_24.ptr->windowHeight) / __tavr_tmp_25.ptr->windowWidth);
					}
					__tavr_tmp_18 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
					__tavr_tmp_20 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_20);
					__tavr_tmp_26 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_26);
					__tavr_tmp_27 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_27);
					__tavr_tmp_28 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_28);
					__tavr_tmp_29 = (__tavr_tmp_27.ptr->width / __tavr_tmp_28.ptr->windowWidth);
					__tavr_tmp_30 = (__tavr_tmp_20.ptr->height / __tavr_tmp_26.ptr->windowHeight);
					__tavr__EngV2___EngV2___float___float(&__tavr_tmp_31, __tavr_tmp_29, __tavr_tmp_30);
					__tavr_tmp_18.ptr->wnd2scr = __tavr_tmp_31;
					__tavr_tmp_18 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
					__tavr_tmp_20 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_20);
					__tavr_tmp_26 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_26);
					__tavr_tmp_27 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_27);
					__tavr_tmp_29 = (__tavr_tmp_27.ptr->width / 2.f);
					__tavr_tmp_30 = (__tavr_tmp_26.ptr->height / 2.f);
					__tavr__EngV2___EngV2___float___float(&__tavr_tmp_31, __tavr_tmp_29, __tavr_tmp_30);
					__tavr_tmp_32 = &__tavr_tmp_20.ptr->defGravityCenter;
					(*__tavr_tmp_32) = __tavr_tmp_31;
					__tavr_tmp_18.ptr->gravityCenter = (*__tavr_tmp_32);
					__tavr_tmp_19 = event;
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_19);
					__tavr_tmp_21 = __tavr_tmp_19.ptr->isReset;
					if(__tavr_tmp_21)
					{
						struct __tavr_ref_string __tavr_tmp_33;
						struct __tavr_ref_string __tavr_tmp_34;
						struct __tavr_ref_EngShader __tavr_tmp_35;
						struct __tavr_ref_EngShader* __tavr_tmp_36;
						__tavr_tmp_18 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
						__tavr__EngShader___release(&__tavr_tmp_18.ptr->shaderCircle);
						__tavr_tmp_18 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
						__tavr__EngShader___release(&__tavr_tmp_18.ptr->shaderTransform);
						__tavr_tmp_18 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
						__tavr_tmp_20 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_20);
						__tavr_tmp_33.ref = __tavr_alloc_string(L"data\\circle.psh");
						__tavr_tmp_33.ptr = (void*)(__tavr_tmp_33.ref+2);
						__tavr_tmp_34 = __tavr_tmp_33;
						__TAVR_INC_REF(__tavr_tmp_34);
						__tavr_tmp_35 = __tavr__Engine___loadPixelShader___string(&__tavr_tmp_20.ptr->engine, __tavr_tmp_34);
						__tavr_tmp_36 = &__tavr_tmp_18.ptr->shaderCircle;
						__TAVR_DEC_REF((*__tavr_tmp_36));
						(*__tavr_tmp_36) = __tavr_tmp_35;
						__TAVR_INC_REF((*__tavr_tmp_36));
						__TAVR_DEC_REF(__tavr_tmp_35);
						__TAVR_DEC_REF(__tavr_tmp_33);
						__tavr_tmp_18 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
						__tavr_tmp_20 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_20);
						__tavr_tmp_33.ref = __tavr_alloc_string(L"data\\transform.vsh");
						__tavr_tmp_33.ptr = (void*)(__tavr_tmp_33.ref+2);
						__tavr_tmp_34 = __tavr_tmp_33;
						__TAVR_INC_REF(__tavr_tmp_34);
						__tavr_tmp_35 = __tavr__Engine___loadVertexShader___string(&__tavr_tmp_20.ptr->engine, __tavr_tmp_34);
						__tavr_tmp_36 = &__tavr_tmp_18.ptr->shaderTransform;
						__TAVR_DEC_REF((*__tavr_tmp_36));
						(*__tavr_tmp_36) = __tavr_tmp_35;
						__TAVR_INC_REF((*__tavr_tmp_36));
						__TAVR_DEC_REF(__tavr_tmp_35);
						__TAVR_DEC_REF(__tavr_tmp_33);
					}
					__tavr_tmp_18 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
					__tavr_tmp_20 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_20);
					__tavr_tmp_37.ref = __tavr_alloc_string(L"width");
					__tavr_tmp_37.ptr = (void*)(__tavr_tmp_37.ref+2);
					__tavr_tmp_38 = __tavr_tmp_37;
					__TAVR_INC_REF(__tavr_tmp_38);
					__tavr_tmp_29 = __tavr_tmp_20.ptr->width;
					__tavr__EngShader___set___string___float(&__tavr_tmp_18.ptr->shaderTransform, __tavr_tmp_38, __tavr_tmp_29);
					__TAVR_DEC_REF(__tavr_tmp_37);
					__tavr_tmp_18 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_18);
					__tavr_tmp_20 = (*__tavr_this);
					__TAVR_ASSERT_NULL_PTR(__tavr_tmp_20);
					__tavr_tmp_37.ref = __tavr_alloc_string(L"height");
					__tavr_tmp_37.ptr = (void*)(__tavr_tmp_37.ref+2);
					__tavr_tmp_38 = __tavr_tmp_37;
					__TAVR_INC_REF(__tavr_tmp_38);
					__tavr_tmp_29 = __tavr_tmp_20.ptr->height;
					__tavr__EngShader___set___string___float(&__tavr_tmp_18.ptr->shaderTransform, __tavr_tmp_38, __tavr_tmp_29);
					__TAVR_DEC_REF(__tavr_tmp_37);
				}
				__TAVR_DEC_REF(event);
			}
			else
			{
			}
		}
		__tavr_this->ptr->__tavr_relax = 1;
		return ;
	}
	__tavr_this->ptr->__tavr_relax = 0;
}
void __tavr__Game___includeBall___GameBall(struct __tavr_ref_Game* __tavr_this, struct __tavr_ref_GameBall ball)
{
	{
		__tavr_int i;
		struct __tavr_ref_Game __tavr_tmp_39;
		struct __tavr_array_GameBall __tavr_tmp_40;
		__tavr_bool __tavr_tmp_41;
		i = 0;
__tavr_label_3: ;
		__tavr_tmp_39 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_39);
		__tavr_tmp_40 = __tavr_tmp_39.ptr->balls;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_40);
		__tavr_tmp_41 = (i < __TAVR_ARRAY_LENGTH(__tavr_tmp_40));
		if(__tavr_tmp_41)
		{
			__tavr_int __tavr_tmp_42;
			struct __tavr_ref_GameBall* __tavr_tmp_43;
			__tavr_tmp_39 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_39);
			__tavr_tmp_40 = __tavr_tmp_39.ptr->balls;
			__tavr_tmp_42 = i;
			__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_40, __tavr_tmp_42);
			__tavr_tmp_41 = (__tavr_tmp_40.ptr[__tavr_tmp_42].ref != 0);
			if(__tavr_tmp_41)
			{
				goto __tavr_label_4;
			}
			__tavr_tmp_39 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_39);
			__tavr_tmp_40 = __tavr_tmp_39.ptr->balls;
			__tavr_tmp_42 = i;
			__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_40, __tavr_tmp_42);
			__tavr_tmp_43 = &__tavr_tmp_40.ptr[__tavr_tmp_42];
			__TAVR_DEC_REF((*__tavr_tmp_43));
			(*__tavr_tmp_43) = ball;
			__TAVR_INC_REF((*__tavr_tmp_43));
			__TAVR_INC_REF(ball);
			__tavr_add_out_list(&(*__tavr_this).ptr->__tavr_out_update, *(__tavr_ref_t*)&ball, (__tavr_auto_proc_t)__tavr__GameBall___auto_0, 0);
			__TAVR_INC_REF(ball);
			__tavr_add_out_list(&(*__tavr_this).ptr->__tavr_out_render, *(__tavr_ref_t*)&ball, (__tavr_auto_proc_t)__tavr__GameBall___auto_1, 0);
			__TAVR_DEC_REF(ball);
			return ;
		}
		else
		goto __tavr_label_5;
__tavr_label_4: ;
		{
			++i;
		}
		goto __tavr_label_3;
__tavr_label_5: ;
	}
	__TAVR_DEC_REF(ball);
}
void __tavr__Game___excludeBall___GameBall(struct __tavr_ref_Game* __tavr_this, struct __tavr_ref_GameBall ball)
{
	{
		__tavr_int i;
		struct __tavr_ref_Game __tavr_tmp_44;
		struct __tavr_array_GameBall __tavr_tmp_45;
		__tavr_bool __tavr_tmp_46;
		i = 0;
__tavr_label_6: ;
		__tavr_tmp_44 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_44);
		__tavr_tmp_45 = __tavr_tmp_44.ptr->balls;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_45);
		__tavr_tmp_46 = (i < __TAVR_ARRAY_LENGTH(__tavr_tmp_45));
		if(__tavr_tmp_46)
		{
			__tavr_int __tavr_tmp_47;
			__tavr_tmp_44 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_44);
			__tavr_tmp_45 = __tavr_tmp_44.ptr->balls;
			__tavr_tmp_47 = i;
			__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_45, __tavr_tmp_47);
			__tavr_tmp_46 = (__tavr_tmp_45.ptr[__tavr_tmp_47].ref != ball.ref);
			if(__tavr_tmp_46)
			{
				goto __tavr_label_7;
			}
			__tavr_tmp_44 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_44);
			__tavr_tmp_45 = __tavr_tmp_44.ptr->balls;
			__tavr_tmp_47 = i;
			__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_45, __tavr_tmp_47);
			__TAVR_DEC_REF(__tavr_tmp_45.ptr[__tavr_tmp_47]);
			__tavr_tmp_45.ptr[__tavr_tmp_47].ptr = 0;
			__tavr_tmp_45.ptr[__tavr_tmp_47].ref = 0;
			__TAVR_INC_REF(ball);
			__tavr_remove_out_list(&(*__tavr_this).ptr->__tavr_out_update, *(__tavr_ref_t*)&ball);
			__TAVR_INC_REF(ball);
			__tavr_remove_out_list(&(*__tavr_this).ptr->__tavr_out_render, *(__tavr_ref_t*)&ball);
			__tavr_tmp_44 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_44);
			--__tavr_tmp_44.ptr->ballsCount;
			__TAVR_DEC_REF(ball);
			return ;
		}
		else
		goto __tavr_label_8;
__tavr_label_7: ;
		{
			++i;
		}
		goto __tavr_label_6;
__tavr_label_8: ;
	}
	__TAVR_DEC_REF(ball);
}
void __tavr__Game___run(struct __tavr_ref_Game* __tavr_this)
{
	struct __tavr_ref_Game __tavr_tmp_48;
	__tavr_tmp_48 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_48);
	__tavr__Engine___run(&__tavr_tmp_48.ptr->engine);
	__tavr_tmp_48 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_48);
	__tavr__EngShader___release(&__tavr_tmp_48.ptr->shaderCircle);
	__tavr_tmp_48 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_48);
	__tavr__EngShader___release(&__tavr_tmp_48.ptr->shaderTransform);
	__tavr_tmp_48 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_48);
	__tavr__Engine___release(&__tavr_tmp_48.ptr->engine);
	__tavr_tmp_48 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_48);
	__TAVR_DEC_REF(__tavr_tmp_48.ptr->engine);
	__tavr_tmp_48.ptr->engine.ptr = 0;
	__tavr_tmp_48.ptr->engine.ref = 0;
	{
		__tavr_int i;
		struct __tavr_array_GameBall __tavr_tmp_49;
		__tavr_bool __tavr_tmp_50;
		i = 0;
__tavr_label_9: ;
		__tavr_tmp_48 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_48);
		__tavr_tmp_49 = __tavr_tmp_48.ptr->balls;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_49);
		__tavr_tmp_50 = (i < __TAVR_ARRAY_LENGTH(__tavr_tmp_49));
		if(__tavr_tmp_50)
		{
			__tavr_int __tavr_tmp_51;
			__tavr_tmp_48 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_48);
			__tavr_tmp_49 = __tavr_tmp_48.ptr->balls;
			__tavr_tmp_51 = i;
			__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_49, __tavr_tmp_51);
			__TAVR_INC_REF(__tavr_tmp_49.ptr[__tavr_tmp_51]);
			__tavr_remove_out_list(&(*__tavr_this).ptr->__tavr_out_update, *(__tavr_ref_t*)&__tavr_tmp_49.ptr[__tavr_tmp_51]);
			__tavr_tmp_48 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_48);
			__tavr_tmp_49 = __tavr_tmp_48.ptr->balls;
			__tavr_tmp_51 = i;
			__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_49, __tavr_tmp_51);
			__TAVR_INC_REF(__tavr_tmp_49.ptr[__tavr_tmp_51]);
			__tavr_remove_out_list(&(*__tavr_this).ptr->__tavr_out_render, *(__tavr_ref_t*)&__tavr_tmp_49.ptr[__tavr_tmp_51]);
		}
		else
		goto __tavr_label_10;
		{
			++i;
		}
		goto __tavr_label_9;
__tavr_label_10: ;
	}
	__tavr_tmp_48 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_48);
	__TAVR_DEC_REF(__tavr_tmp_48.ptr->balls);
	__tavr_tmp_48.ptr->balls.ptr = 0;
	__tavr_tmp_48.ptr->balls.ref = 0;
}
void __tavr__Game___Game(struct __tavr_ref_Game* __tavr_this)
{
	struct __tavr_ref_Game __tavr_tmp_52;
	struct __tavr_ref_Game __tavr_tmp_53;
	struct __tavr_ref_Game __tavr_tmp_54;
	struct __tavr_ref_Game __tavr_tmp_55;
	struct __tavr_ref_Game __tavr_tmp_56;
	struct __tavr_ref_Game __tavr_tmp_57;
	__tavr_float __tavr_tmp_58;
	__tavr_float __tavr_tmp_59;
	struct EngV2 __tavr_tmp_60;
	struct __tavr_ref_Game __tavr_tmp_61;
	struct __tavr_ref_Game __tavr_tmp_62;
	struct __tavr_ref_Game __tavr_tmp_63;
	struct __tavr_ref_Game __tavr_tmp_64;
	__tavr_float __tavr_tmp_65;
	__tavr_float __tavr_tmp_66;
	struct EngV2 __tavr_tmp_67;
	__tavr_this->ptr->__tavr_relax = 0;
	__tavr_this->ptr->__tavr_out_render = 0;
	__tavr_this->ptr->__tavr_out_update = 0;
	__tavr_this->ptr->engine.ptr = 0;
	__tavr_this->ptr->engine.ref = 0;
	__tavr_this->ptr->shaderCircle.ptr = 0;
	__tavr_this->ptr->shaderCircle.ref = 0;
	__tavr_this->ptr->shaderTransform.ptr = 0;
	__tavr_this->ptr->shaderTransform.ref = 0;
	__tavr_this->ptr->windowWidth = 800.f;
	__tavr_this->ptr->windowHeight = 600.f;
	__tavr_this->ptr->width = 1024.f;
	__tavr_this->ptr->height = 768.f;
	__tavr_tmp_61 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_61);
	__tavr_tmp_62 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_62);
	__tavr_tmp_63 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_63);
	__tavr_tmp_64 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_64);
	__tavr_tmp_65 = (__tavr_tmp_63.ptr->width / __tavr_tmp_64.ptr->windowWidth);
	__tavr_tmp_66 = (__tavr_tmp_61.ptr->height / __tavr_tmp_62.ptr->windowHeight);
	__tavr__EngV2___EngV2___float___float(&__tavr_tmp_67, __tavr_tmp_65, __tavr_tmp_66);
	__tavr_this->ptr->wnd2scr = __tavr_tmp_67;
	__tavr_tmp_56 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_56);
	__tavr_tmp_57 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_57);
	__tavr_tmp_58 = (__tavr_tmp_57.ptr->width / 2.f);
	__tavr_tmp_59 = (__tavr_tmp_56.ptr->height / 2.f);
	__tavr__EngV2___EngV2___float___float(&__tavr_tmp_60, __tavr_tmp_58, __tavr_tmp_59);
	__tavr_this->ptr->defGravityCenter = __tavr_tmp_60;
	__tavr_tmp_55 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_55);
	__tavr_this->ptr->gravityCenter = __tavr_tmp_55.ptr->defGravityCenter;
	__tavr_this->ptr->gravityEnable = 1;
	__tavr_this->ptr->gravityCoef = 10000.f;
	__tavr_this->ptr->maxSpeed = 25.f;
	__tavr_this->ptr->maxAcceler = 75.f;
	__tavr_this->ptr->massCoef = 0.1f;
	__tavr_this->ptr->rigidCoef = 100000000.f;
	__tavr_this->ptr->mergeBarrier = 0.15f;
	__tavr_this->ptr->ballRadius = 19.f;
	__tavr_this->ptr->ballRadiusRangeCoef = 0.4f;
	__tavr_tmp_53 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_53);
	__tavr_tmp_54 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_54);
	__tavr_this->ptr->explodeBarrier = ((__tavr_tmp_53.ptr->ballRadius * 5.5f) * __tavr_tmp_54.ptr->ballRadiusRangeCoef);
	__tavr_this->ptr->timeFactor = 3.f;
	__tavr_this->ptr->changeGravTimeCoef = 1.5f;
	__tavr_this->ptr->changeSingleGravTimeCoef = 1.8f;
	__tavr_this->ptr->explodeBallsCount = 20;
	__tavr_tmp_52 = (*__tavr_this);
	__TAVR_ASSERT_NULL_PTR(__tavr_tmp_52);
	__tavr_this->ptr->explodeSpeed = (__tavr_tmp_52.ptr->maxAcceler * 2.f);
	__tavr_this->ptr->ballsCountMax = 100;
	__tavr_this->ptr->ballsCount = 0;
	__tavr_this->ptr->balls.ptr = 0;
	__tavr_this->ptr->balls.ref = 0;
	{
		struct __tavr_ref_Game __tavr_tmp_68;
		struct __tavr_ref_string __tavr_tmp_69;
		struct __tavr_ref_string __tavr_tmp_70;
		__tavr_int __tavr_tmp_71;
		__tavr_int __tavr_tmp_72;
		struct __tavr_ref_Engine __tavr_tmp_73;
		struct __tavr_ref_Engine* __tavr_tmp_74;
		struct __tavr_ref_Game __tavr_tmp_75;
		struct __tavr_ref_GameController __tavr_tmp_76;
		struct __tavr_ref_EngShader __tavr_tmp_77;
		struct __tavr_ref_EngShader* __tavr_tmp_78;
		__tavr_float __tavr_tmp_79;
		__tavr_tmp_68 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_68);
		__tavr_tmp_69.ref = __tavr_alloc_string(L"TavrGame v1.0");
		__tavr_tmp_69.ptr = (void*)(__tavr_tmp_69.ref+2);
		__tavr_tmp_70 = __tavr_tmp_69;
		__TAVR_INC_REF(__tavr_tmp_70);
		__tavr_tmp_71 = 800;
		__tavr_tmp_72 = 600;
		__tavr_tmp_73.ref = __tavr_alloc(60, __tavr_ti_Engine);
		__tavr_tmp_73.ptr = (void*)(__tavr_tmp_73.ref+2);
		__tavr__Engine___Engine___string___int___int(&__tavr_tmp_73, __tavr_tmp_70, __tavr_tmp_71, __tavr_tmp_72);
		__tavr_tmp_74 = &__tavr_tmp_68.ptr->engine;
		__TAVR_DEC_REF((*__tavr_tmp_74));
		(*__tavr_tmp_74) = __tavr_tmp_73;
		__TAVR_INC_REF((*__tavr_tmp_74));
		__TAVR_DEC_REF(__tavr_tmp_73);
		__TAVR_DEC_REF(__tavr_tmp_69);
		__tavr_tmp_68 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_68);
		__TAVR_INC_REF((*__tavr_this));
		__tavr_add_out_list(&__tavr_tmp_68.ptr->engine.ptr->__tavr_out_update, *(__tavr_ref_t*)&(*__tavr_this), (__tavr_auto_proc_t)__tavr__Game___auto, 0);
		__tavr_tmp_68 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_68);
		__TAVR_INC_REF((*__tavr_this));
		__tavr_add_out_list(&__tavr_tmp_68.ptr->engine.ptr->__tavr_out_resize, *(__tavr_ref_t*)&(*__tavr_this), (__tavr_auto_proc_t)__tavr__Game___auto, 0);
		__tavr_tmp_68 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_68);
		__tavr_tmp_75 = (*__tavr_this);
		__TAVR_INC_REF(__tavr_tmp_75);
		__tavr_tmp_76.ref = __tavr_alloc(52, __tavr_ti_GameController);
		__tavr_tmp_76.ptr = (void*)(__tavr_tmp_76.ref+2);
		__tavr__GameController___GameController___Game(&__tavr_tmp_76, __tavr_tmp_75);
		__TAVR_INC_REF(__tavr_tmp_76);
		__tavr_add_out_list(&__tavr_tmp_68.ptr->engine.ptr->__tavr_out_mouse, *(__tavr_ref_t*)&__tavr_tmp_76, (__tavr_auto_proc_t)__tavr__GameController___auto, 0);
		__TAVR_DEC_REF(__tavr_tmp_76);
		__tavr_tmp_68 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_68);
		__tavr_tmp_75 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_75);
		__tavr_tmp_69.ref = __tavr_alloc_string(L"data\\circle.psh");
		__tavr_tmp_69.ptr = (void*)(__tavr_tmp_69.ref+2);
		__tavr_tmp_70 = __tavr_tmp_69;
		__TAVR_INC_REF(__tavr_tmp_70);
		__tavr_tmp_77 = __tavr__Engine___loadPixelShader___string(&__tavr_tmp_75.ptr->engine, __tavr_tmp_70);
		__tavr_tmp_78 = &__tavr_tmp_68.ptr->shaderCircle;
		__TAVR_DEC_REF((*__tavr_tmp_78));
		(*__tavr_tmp_78) = __tavr_tmp_77;
		__TAVR_INC_REF((*__tavr_tmp_78));
		__TAVR_DEC_REF(__tavr_tmp_77);
		__TAVR_DEC_REF(__tavr_tmp_69);
		__tavr_tmp_68 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_68);
		__tavr_tmp_75 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_75);
		__tavr_tmp_69.ref = __tavr_alloc_string(L"data\\transform.vsh");
		__tavr_tmp_69.ptr = (void*)(__tavr_tmp_69.ref+2);
		__tavr_tmp_70 = __tavr_tmp_69;
		__TAVR_INC_REF(__tavr_tmp_70);
		__tavr_tmp_77 = __tavr__Engine___loadVertexShader___string(&__tavr_tmp_75.ptr->engine, __tavr_tmp_70);
		__tavr_tmp_78 = &__tavr_tmp_68.ptr->shaderTransform;
		__TAVR_DEC_REF((*__tavr_tmp_78));
		(*__tavr_tmp_78) = __tavr_tmp_77;
		__TAVR_INC_REF((*__tavr_tmp_78));
		__TAVR_DEC_REF(__tavr_tmp_77);
		__TAVR_DEC_REF(__tavr_tmp_69);
		__tavr_tmp_68 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_68);
		__tavr_tmp_75 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_75);
		__tavr_tmp_69.ref = __tavr_alloc_string(L"width");
		__tavr_tmp_69.ptr = (void*)(__tavr_tmp_69.ref+2);
		__tavr_tmp_70 = __tavr_tmp_69;
		__TAVR_INC_REF(__tavr_tmp_70);
		__tavr_tmp_79 = __tavr_tmp_75.ptr->width;
		__tavr__EngShader___set___string___float(&__tavr_tmp_68.ptr->shaderTransform, __tavr_tmp_70, __tavr_tmp_79);
		__TAVR_DEC_REF(__tavr_tmp_69);
		__tavr_tmp_68 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_68);
		__tavr_tmp_75 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_75);
		__tavr_tmp_69.ref = __tavr_alloc_string(L"height");
		__tavr_tmp_69.ptr = (void*)(__tavr_tmp_69.ref+2);
		__tavr_tmp_70 = __tavr_tmp_69;
		__TAVR_INC_REF(__tavr_tmp_70);
		__tavr_tmp_79 = __tavr_tmp_75.ptr->height;
		__tavr__EngShader___set___string___float(&__tavr_tmp_68.ptr->shaderTransform, __tavr_tmp_70, __tavr_tmp_79);
		__TAVR_DEC_REF(__tavr_tmp_69);
	}
}
void __tavr__Game___destr_Game(struct __tavr_ref_Game* __tavr_this)
{
	__tavr_release_out_list(&__tavr_this->ptr->__tavr_out_render);
	__tavr_release_out_list(&__tavr_this->ptr->__tavr_out_update);
	__TAVR_DEC_REF(__tavr_this->ptr->engine);
	__TAVR_DEC_REF(__tavr_this->ptr->shaderCircle);
	__TAVR_DEC_REF(__tavr_this->ptr->shaderTransform);
	__TAVR_DEC_REF(__tavr_this->ptr->balls);
	switch (__tavr_this->ptr->__tavr_relax) {
		case 1:
			break;
		default: if (__tavr_this->ptr->__tavr_relax != 0) __TAVR_UNKNOWN_RELAX_CONTEXT(); break;
	}
}
void __tavr__GameRender___GameRender___Game(struct __tavr_ref_GameRender* __tavr_this, struct __tavr_ref_Game game)
{
	__tavr_this->ptr->game = game;
	__TAVR_INC_REF(__tavr_this->ptr->game);
	__TAVR_DEC_REF(game);
}
void __tavr__GameRender___destr_GameRender(struct __tavr_ref_GameRender* __tavr_this)
{
	__TAVR_DEC_REF(__tavr_this->ptr->game);
}
void __tavr__GameUpdate___GameUpdate___float___Game(struct __tavr_ref_GameUpdate* __tavr_this, __tavr_float elapsedTime, struct __tavr_ref_Game game)
{
	__tavr_this->ptr->game = game;
	__TAVR_INC_REF(__tavr_this->ptr->game);
	__tavr_this->ptr->elapsedTime = elapsedTime;
	__TAVR_DEC_REF(game);
}
void __tavr__GameUpdate___destr_GameUpdate(struct __tavr_ref_GameUpdate* __tavr_this)
{
	__TAVR_DEC_REF(__tavr_this->ptr->game);
}
