#include <tavr_runtime.h>
struct Engine {
	void * __tavr_out_mouse;
	void * __tavr_out_resize;
	void * __tavr_out_update;
	__tavr_int MOUSE_ACTION_DOWN;
	__tavr_int MOUSE_ACTION_UP;
	__tavr_int MOUSE_ACTION_MOVE;
	__tavr_int MOUSE_BUTTON_LEFT;
	__tavr_int MOUSE_BUTTON_RIGHT;
	__tavr_int MOUSE_BUTTON_MIDDLE;
	__tavr_double timer;
	__tavr_float fps;
	__tavr_int fpsCounter;
	__tavr_float fpsTimer;
	__tavr_int implData;
};
void __tavr__Engine___destr_Engine(struct __tavr_ref_Engine* __tavr_this);
struct __tavr_ref_Engine {
	__tavr_int* ref;
	struct Engine* ptr;
};
void * __tavr_ti_Engine[];
struct EngShader {
	__tavr_int implData;
};
void __tavr__EngShader___destr_EngShader(struct __tavr_ref_EngShader* __tavr_this);
struct __tavr_ref_EngShader {
	__tavr_int* ref;
	struct EngShader* ptr;
};
void * __tavr_ti_EngShader[];
struct EngV2 {
	__tavr_float x;
	__tavr_float y;
};
struct __tavr_array_GameBall {
	__tavr_int* ref;
	struct __tavr_ref_GameBall* ptr;
};
struct EngColor {
	__tavr_float r;
	__tavr_float g;
	__tavr_float b;
	__tavr_float a;
};
struct GameBall {
	__tavr_int __tavr_relax_0;
	__tavr_byte __tavr_stack_0[88];
	struct EngV2 pos;
	struct EngV2 speed;
	__tavr_float radius;
	struct EngColor color;
};
void __tavr__GameBall___destr_GameBall(struct __tavr_ref_GameBall* __tavr_this);
struct __tavr_ref_GameBall {
	__tavr_int* ref;
	struct GameBall* ptr;
};
void * __tavr_ti_GameBall[];
void * __tavr_ti_GameBall_a[];
struct Game {
	__tavr_int __tavr_relax;
	void * __tavr_out_render;
	void * __tavr_out_update;
	struct __tavr_ref_Engine engine;
	struct __tavr_ref_EngShader shaderCircle;
	struct __tavr_ref_EngShader shaderTransform;
	__tavr_float windowWidth;
	__tavr_float windowHeight;
	__tavr_float width;
	__tavr_float height;
	struct EngV2 wnd2scr;
	struct EngV2 defGravityCenter;
	struct EngV2 gravityCenter;
	__tavr_bool gravityEnable;
	__tavr_float gravityCoef;
	__tavr_float maxSpeed;
	__tavr_float maxAcceler;
	__tavr_float massCoef;
	__tavr_float rigidCoef;
	__tavr_float mergeBarrier;
	__tavr_float ballRadius;
	__tavr_float ballRadiusRangeCoef;
	__tavr_float explodeBarrier;
	__tavr_float timeFactor;
	__tavr_float changeGravTimeCoef;
	__tavr_float changeSingleGravTimeCoef;
	__tavr_int explodeBallsCount;
	__tavr_float explodeSpeed;
	__tavr_int ballsCountMax;
	__tavr_int ballsCount;
	struct __tavr_array_GameBall balls;
};
void __tavr__Game___destr_Game(struct __tavr_ref_Game* __tavr_this);
struct __tavr_ref_Game {
	__tavr_int* ref;
	struct Game* ptr;
};
void * __tavr_ti_Game[];
struct GameController {
	__tavr_int __tavr_relax;
	__tavr_byte __tavr_stack[24];
	struct __tavr_ref_Game game;
	__tavr_float clickTimer;
	__tavr_float doubleClickTimer;
	__tavr_float lastClick;
	__tavr_float lastDown;
};
void __tavr__GameController___destr_GameController(struct __tavr_ref_GameController* __tavr_this);
struct __tavr_ref_GameController {
	__tavr_int* ref;
	struct GameController* ptr;
};
void * __tavr_ti_GameController[];
void __tavr__GameController___auto(struct __tavr_ref_GameController* __tavr_this);
struct EngMouse {
	struct __tavr_ref_Engine engine;
	__tavr_int action;
	__tavr_int button;
	struct EngV2 pos;
};
void __tavr__EngMouse___destr_EngMouse(struct __tavr_ref_EngMouse* __tavr_this);
struct __tavr_ref_EngMouse {
	__tavr_int* ref;
	struct EngMouse* ptr;
};
void * __tavr_ti_EngMouse[];
__tavr_bool __tavr__EngMouse___isRight___bool(struct __tavr_ref_EngMouse* __tavr_this, __tavr_bool isDown);
struct EngV2 __tavr__EngV2___mul___EngV2_r(struct EngV2* __tavr_this, struct EngV2* v);
__tavr_bool __tavr__EngMouse___isMiddle___bool(struct __tavr_ref_EngMouse* __tavr_this, __tavr_bool isDown);
__tavr_bool __tavr__EngMouse___isLeft___bool(struct __tavr_ref_EngMouse* __tavr_this, __tavr_bool isDown);
void __tavr__EngV2___EngV2(struct EngV2* __tavr_this);
struct __tavr_ref_GameBall __tavr__GameController___captureBall___EngV2_r(struct __tavr_ref_GameController* __tavr_this, struct EngV2* pos);
struct GameChangeGravity {
	struct __tavr_ref_Game game;
	__tavr_bool enable;
	struct EngV2 pos;
};
struct __tavr_ref_GameChangeGravity {
	__tavr_int* ref;
	struct GameChangeGravity* ptr;
};
void * __tavr_ti_GameChangeGravity[];
void __tavr__GameChangeGravity___destr_GameChangeGravity(struct __tavr_ref_GameChangeGravity* __tavr_this);
void __tavr__GameChangeGravity___GameChangeGravity___Game___bool___EngV2(struct __tavr_ref_GameChangeGravity* __tavr_this, struct __tavr_ref_Game game, __tavr_bool enable, struct EngV2 pos);
void __tavr__GameBall___auto(struct __tavr_ref_GameBall* __tavr_this);
__tavr_bool __tavr__EngMouse___isMove(struct __tavr_ref_EngMouse* __tavr_this);
struct EngV2 __tavr__EngV2___sub___EngV2_r(struct EngV2* __tavr_this, struct EngV2* v);
__tavr_float __tavr__EngV2___length__2(struct EngV2* __tavr_this);
void __tavr__GameController___auto(struct __tavr_ref_GameController* __tavr_this)
{
	switch (__tavr_this->ptr->__tavr_relax) {
		__TAVR_RELAX_CASE_DEFAULT2();
		__TAVR_RELAX_CASE2(4, __tavr_label_0);
		__TAVR_RELAX_CASE2(3, __tavr_label_1);
		__TAVR_RELAX_CASE2(1, __tavr_label_3);
		__TAVR_RELAX_CASE2(2, __tavr_label_4);
		default: __TAVR_UNKNOWN_RELAX_CONTEXT(); return ;
	}
	{
__tavr_label_0: ;
		{
			if (__tavr_cur_event.ref != 0 && ((int*)__tavr_cur_event.ref[1])[2] == 2)
			{
				(*(struct __tavr_ref_EngMouse*)(__tavr_this->ptr->__tavr_stack+0)) = (*(struct __tavr_ref_EngMouse*)&__tavr_cur_event);
				__TAVR_INC_REF((*(struct __tavr_ref_EngMouse*)(__tavr_this->ptr->__tavr_stack+0)));
				__TAVR_DEC_REF((*(struct __tavr_ref_EngMouse*)&__tavr_cur_event));
				(*(struct __tavr_ref_EngMouse*)&__tavr_cur_event).ptr = 0;
				(*(struct __tavr_ref_EngMouse*)&__tavr_cur_event).ref = 0;
				{
					__tavr_bool __tavr_tmp_0;
					__tavr_bool __tavr_tmp_1;
					__tavr_tmp_0 = 1;
					__tavr_tmp_1 = __tavr__EngMouse___isRight___bool(&(*(struct __tavr_ref_EngMouse*)(__tavr_this->ptr->__tavr_stack+0)), __tavr_tmp_0);
					if(__tavr_tmp_1)
					{
						struct __tavr_ref_GameController __tavr_tmp_2;
						struct __tavr_ref_Game __tavr_tmp_3;
						struct __tavr_ref_GameController __tavr_tmp_4;
						struct __tavr_ref_Game __tavr_tmp_5;
						struct __tavr_ref_EngMouse __tavr_tmp_6;
						struct EngV2 __tavr_tmp_7;
						struct __tavr_ref_GameController __tavr_tmp_8;
						struct __tavr_ref_Game __tavr_tmp_9;
						__tavr_tmp_2 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_2);
						__tavr_tmp_3 = __tavr_tmp_2.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_3);
						__tavr_tmp_4 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_4);
						__tavr_tmp_5 = __tavr_tmp_4.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_5);
						__tavr_tmp_6 = (*(struct __tavr_ref_EngMouse*)(__tavr_this->ptr->__tavr_stack+0));
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_6);
						__tavr_tmp_7 = __tavr__EngV2___mul___EngV2_r(&__tavr_tmp_5.ptr->wnd2scr, &__tavr_tmp_6.ptr->pos);
						__tavr_tmp_3.ptr->gravityCenter = __tavr_tmp_7;
						__tavr_tmp_2 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_2);
						__tavr_tmp_3 = __tavr_tmp_2.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_3);
						__tavr_tmp_4 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_4);
						__tavr_tmp_5 = __tavr_tmp_4.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_5);
						__tavr_tmp_8 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_8);
						__tavr_tmp_9 = __tavr_tmp_8.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_9);
						__tavr_tmp_3.ptr->timeFactor = (__tavr_tmp_5.ptr->timeFactor * __tavr_tmp_9.ptr->changeGravTimeCoef);
						__TAVR_DEC_REF((*(struct __tavr_ref_EngMouse*)(__tavr_this->ptr->__tavr_stack+0)));
						__tavr_this->ptr->__tavr_relax = 1;
						return ;
					}
					__tavr_tmp_0 = 1;
					__tavr_tmp_1 = __tavr__EngMouse___isMiddle___bool(&(*(struct __tavr_ref_EngMouse*)(__tavr_this->ptr->__tavr_stack+0)), __tavr_tmp_0);
					if(__tavr_tmp_1)
					{
						struct __tavr_ref_GameController __tavr_tmp_10;
						struct __tavr_ref_Game __tavr_tmp_11;
						__tavr_tmp_10 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_10);
						__tavr_tmp_11 = __tavr_tmp_10.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_11);
						__tavr_tmp_11.ptr->gravityEnable = 0;
						__TAVR_DEC_REF((*(struct __tavr_ref_EngMouse*)(__tavr_this->ptr->__tavr_stack+0)));
						__tavr_this->ptr->__tavr_relax = 2;
						return ;
					}
					__tavr_tmp_0 = 1;
					__tavr_tmp_1 = __tavr__EngMouse___isLeft___bool(&(*(struct __tavr_ref_EngMouse*)(__tavr_this->ptr->__tavr_stack+0)), __tavr_tmp_0);
					if(__tavr_tmp_1)
					{
						struct __tavr_ref_GameController __tavr_tmp_12;
						struct __tavr_ref_Game __tavr_tmp_13;
						struct __tavr_ref_EngMouse __tavr_tmp_14;
						struct EngV2 __tavr_tmp_15;
						struct __tavr_ref_GameBall __tavr_tmp_16;
						__tavr_tmp_12 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_12);
						__tavr_tmp_13 = __tavr_tmp_12.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_13);
						__tavr_tmp_14 = (*(struct __tavr_ref_EngMouse*)(__tavr_this->ptr->__tavr_stack+0));
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_14);
						__tavr_tmp_15 = __tavr__EngV2___mul___EngV2_r(&__tavr_tmp_13.ptr->wnd2scr, &__tavr_tmp_14.ptr->pos);
						(*(struct EngV2*)(__tavr_this->ptr->__tavr_stack+8)) = __tavr_tmp_15;
						__tavr_tmp_16 = __tavr__GameController___captureBall___EngV2_r(&(*__tavr_this), &(*(struct EngV2*)(__tavr_this->ptr->__tavr_stack+8)));
						(*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack+16)) = __tavr_tmp_16;
						__TAVR_INC_REF((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack+16)));
						__TAVR_DEC_REF(__tavr_tmp_16);
						if(((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack+16)).ref != 0))
						{
							struct __tavr_ref_GameChangeGravity __tavr_tmp_17;
							__tavr_tmp_12 = (*__tavr_this);
							__TAVR_ASSERT_NULL_PTR(__tavr_tmp_12);
							__tavr_tmp_13 = __tavr_tmp_12.ptr->game;
							__TAVR_INC_REF(__tavr_tmp_13);
							__tavr_tmp_0 = 1;
							__tavr_tmp_15 = (*(struct EngV2*)(__tavr_this->ptr->__tavr_stack+8));
							__tavr_tmp_17.ref = __tavr_alloc(17, __tavr_ti_GameChangeGravity);
							__tavr_tmp_17.ptr = (void*)(__tavr_tmp_17.ref+2);
							__tavr__GameChangeGravity___GameChangeGravity___Game___bool___EngV2(&__tavr_tmp_17, __tavr_tmp_13, __tavr_tmp_0, __tavr_tmp_15);
							__tavr_add_post_layer();
							__tavr_cur_event = *(__tavr_ref_t*)&__tavr_tmp_17;
							__TAVR_INC_REF(__tavr_cur_event);
							__tavr__GameBall___auto(&(*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack+16)));
							__TAVR_DEC_REF(__tavr_cur_event);
							__tavr_cur_event.ptr = __tavr_cur_event.ref = 0;
							__tavr_remove_post_layer();
							__TAVR_DEC_REF(__tavr_tmp_17);
__tavr_label_1: ;
							{
								if (__tavr_cur_event.ref != 0 && ((int*)__tavr_cur_event.ref[1])[2] == 2)
								{
									struct __tavr_ref_EngMouse event;
									event = (*(struct __tavr_ref_EngMouse*)&__tavr_cur_event);
									__TAVR_INC_REF(event);
									__TAVR_DEC_REF((*(struct __tavr_ref_EngMouse*)&__tavr_cur_event));
									(*(struct __tavr_ref_EngMouse*)&__tavr_cur_event).ptr = 0;
									(*(struct __tavr_ref_EngMouse*)&__tavr_cur_event).ref = 0;
									{
										__tavr_tmp_0 = 0;
										__tavr_tmp_1 = __tavr__EngMouse___isLeft___bool(&event, __tavr_tmp_0);
										if(__tavr_tmp_1)
										{
											__tavr_tmp_12 = (*__tavr_this);
											__TAVR_ASSERT_NULL_PTR(__tavr_tmp_12);
											__tavr_tmp_13 = __tavr_tmp_12.ptr->game;
											__TAVR_INC_REF(__tavr_tmp_13);
											__tavr_tmp_0 = 0;
											__tavr_tmp_15 = (*(struct EngV2*)(__tavr_this->ptr->__tavr_stack+8));
											__tavr_tmp_17.ref = __tavr_alloc(17, __tavr_ti_GameChangeGravity);
											__tavr_tmp_17.ptr = (void*)(__tavr_tmp_17.ref+2);
											__tavr__GameChangeGravity___GameChangeGravity___Game___bool___EngV2(&__tavr_tmp_17, __tavr_tmp_13, __tavr_tmp_0, __tavr_tmp_15);
											__tavr_add_post_layer();
											__tavr_cur_event = *(__tavr_ref_t*)&__tavr_tmp_17;
											__TAVR_INC_REF(__tavr_cur_event);
											__tavr__GameBall___auto(&(*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack+16)));
											__TAVR_DEC_REF(__tavr_cur_event);
											__tavr_cur_event.ptr = __tavr_cur_event.ref = 0;
											__tavr_remove_post_layer();
											__TAVR_DEC_REF(__tavr_tmp_17);
											__TAVR_DEC_REF(event);
											goto __tavr_label_2;
										}
										if(__tavr__EngMouse___isMove(&event))
										{
											__tavr_tmp_12 = (*__tavr_this);
											__TAVR_ASSERT_NULL_PTR(__tavr_tmp_12);
											__tavr_tmp_13 = __tavr_tmp_12.ptr->game;
											__TAVR_ASSERT_NULL_PTR(__tavr_tmp_13);
											__tavr_tmp_14 = event;
											__TAVR_ASSERT_NULL_PTR(__tavr_tmp_14);
											__tavr_tmp_15 = __tavr__EngV2___mul___EngV2_r(&__tavr_tmp_13.ptr->wnd2scr, &__tavr_tmp_14.ptr->pos);
											(*(struct EngV2*)(__tavr_this->ptr->__tavr_stack+8)) = __tavr_tmp_15;
											__tavr_tmp_12 = (*__tavr_this);
											__TAVR_ASSERT_NULL_PTR(__tavr_tmp_12);
											__tavr_tmp_13 = __tavr_tmp_12.ptr->game;
											__TAVR_INC_REF(__tavr_tmp_13);
											__tavr_tmp_0 = 1;
											__tavr_tmp_15 = (*(struct EngV2*)(__tavr_this->ptr->__tavr_stack+8));
											__tavr_tmp_17.ref = __tavr_alloc(17, __tavr_ti_GameChangeGravity);
											__tavr_tmp_17.ptr = (void*)(__tavr_tmp_17.ref+2);
											__tavr__GameChangeGravity___GameChangeGravity___Game___bool___EngV2(&__tavr_tmp_17, __tavr_tmp_13, __tavr_tmp_0, __tavr_tmp_15);
											__tavr_add_post_layer();
											__tavr_cur_event = *(__tavr_ref_t*)&__tavr_tmp_17;
											__TAVR_INC_REF(__tavr_cur_event);
											__tavr__GameBall___auto(&(*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack+16)));
											__TAVR_DEC_REF(__tavr_cur_event);
											__tavr_cur_event.ptr = __tavr_cur_event.ref = 0;
											__tavr_remove_post_layer();
											__TAVR_DEC_REF(__tavr_tmp_17);
										}
									}
									__TAVR_DEC_REF(event);
								}
								else
								{
								}
							}
							__tavr_this->ptr->__tavr_relax = 3;
							return ;
__tavr_label_2: ;
						}
						__TAVR_DEC_REF((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack+16)));
					}
				}
				__TAVR_DEC_REF((*(struct __tavr_ref_EngMouse*)(__tavr_this->ptr->__tavr_stack+0)));
			}
			else
			{
			}
		}
		__tavr_this->ptr->__tavr_relax = 4;
		return ;
__tavr_label_3: ;
		{
			if (__tavr_cur_event.ref != 0 && ((int*)__tavr_cur_event.ref[1])[2] == 2)
			{
				struct __tavr_ref_EngMouse event;
				event = (*(struct __tavr_ref_EngMouse*)&__tavr_cur_event);
				__TAVR_INC_REF(event);
				__TAVR_DEC_REF((*(struct __tavr_ref_EngMouse*)&__tavr_cur_event));
				(*(struct __tavr_ref_EngMouse*)&__tavr_cur_event).ptr = 0;
				(*(struct __tavr_ref_EngMouse*)&__tavr_cur_event).ref = 0;
				{
					__tavr_bool __tavr_tmp_18;
					__tavr_bool __tavr_tmp_19;
					__tavr_tmp_18 = 0;
					__tavr_tmp_19 = __tavr__EngMouse___isRight___bool(&event, __tavr_tmp_18);
					if(__tavr_tmp_19)
					{
						struct __tavr_ref_GameController __tavr_tmp_20;
						struct __tavr_ref_Game __tavr_tmp_21;
						struct __tavr_ref_GameController __tavr_tmp_22;
						struct __tavr_ref_Game __tavr_tmp_23;
						struct __tavr_ref_GameController __tavr_tmp_24;
						struct __tavr_ref_Game __tavr_tmp_25;
						__tavr_tmp_20 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_20);
						__tavr_tmp_21 = __tavr_tmp_20.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
						__tavr_tmp_22 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
						__tavr_tmp_23 = __tavr_tmp_22.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_23);
						__tavr_tmp_21.ptr->gravityCenter = __tavr_tmp_23.ptr->defGravityCenter;
						__tavr_tmp_20 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_20);
						__tavr_tmp_21 = __tavr_tmp_20.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_21);
						__tavr_tmp_22 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_22);
						__tavr_tmp_23 = __tavr_tmp_22.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_23);
						__tavr_tmp_24 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_24);
						__tavr_tmp_25 = __tavr_tmp_24.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_25);
						__tavr_tmp_21.ptr->timeFactor = (__tavr_tmp_23.ptr->timeFactor / __tavr_tmp_25.ptr->changeGravTimeCoef);
						__TAVR_DEC_REF(event);
						__tavr_this->ptr->__tavr_relax = 4;
						return ;
					}
					if(__tavr__EngMouse___isMove(&event))
					{
						struct __tavr_ref_GameController __tavr_tmp_26;
						struct __tavr_ref_Game __tavr_tmp_27;
						struct __tavr_ref_GameController __tavr_tmp_28;
						struct __tavr_ref_Game __tavr_tmp_29;
						struct __tavr_ref_EngMouse __tavr_tmp_30;
						struct EngV2 __tavr_tmp_31;
						__tavr_tmp_26 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_26);
						__tavr_tmp_27 = __tavr_tmp_26.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_27);
						__tavr_tmp_28 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_28);
						__tavr_tmp_29 = __tavr_tmp_28.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_29);
						__tavr_tmp_30 = event;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_30);
						__tavr_tmp_31 = __tavr__EngV2___mul___EngV2_r(&__tavr_tmp_29.ptr->wnd2scr, &__tavr_tmp_30.ptr->pos);
						__tavr_tmp_27.ptr->gravityCenter = __tavr_tmp_31;
					}
				}
				__TAVR_DEC_REF(event);
			}
			else
			{
			}
		}
		__tavr_this->ptr->__tavr_relax = 1;
		return ;
__tavr_label_4: ;
		{
			if (__tavr_cur_event.ref != 0 && ((int*)__tavr_cur_event.ref[1])[2] == 2)
			{
				struct __tavr_ref_EngMouse event;
				event = (*(struct __tavr_ref_EngMouse*)&__tavr_cur_event);
				__TAVR_INC_REF(event);
				__TAVR_DEC_REF((*(struct __tavr_ref_EngMouse*)&__tavr_cur_event));
				(*(struct __tavr_ref_EngMouse*)&__tavr_cur_event).ptr = 0;
				(*(struct __tavr_ref_EngMouse*)&__tavr_cur_event).ref = 0;
				{
					__tavr_bool __tavr_tmp_32;
					__tavr_bool __tavr_tmp_33;
					__tavr_tmp_32 = 0;
					__tavr_tmp_33 = __tavr__EngMouse___isMiddle___bool(&event, __tavr_tmp_32);
					if(__tavr_tmp_33)
					{
						struct __tavr_ref_GameController __tavr_tmp_34;
						struct __tavr_ref_Game __tavr_tmp_35;
						__tavr_tmp_34 = (*__tavr_this);
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_34);
						__tavr_tmp_35 = __tavr_tmp_34.ptr->game;
						__TAVR_ASSERT_NULL_PTR(__tavr_tmp_35);
						__tavr_tmp_35.ptr->gravityEnable = 1;
						__TAVR_DEC_REF(event);
						__tavr_this->ptr->__tavr_relax = 4;
						return ;
					}
				}
				__TAVR_DEC_REF(event);
			}
			else
			{
			}
		}
		__tavr_this->ptr->__tavr_relax = 2;
		return ;
	}
	__tavr_this->ptr->__tavr_relax = 0;
}
struct __tavr_ref_GameBall __tavr__GameController___captureBall___EngV2_r(struct __tavr_ref_GameController* __tavr_this, struct EngV2* pos)
{
	struct __tavr_ref_GameBall __tavr_tmp_44;
	{
		__tavr_int i;
		struct __tavr_ref_GameController __tavr_tmp_36;
		struct __tavr_ref_Game __tavr_tmp_37;
		struct __tavr_array_GameBall __tavr_tmp_38;
		__tavr_bool __tavr_tmp_39;
		i = 0;
__tavr_label_5: ;
		__tavr_tmp_36 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_36);
		__tavr_tmp_37 = __tavr_tmp_36.ptr->game;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_37);
		__tavr_tmp_38 = __tavr_tmp_37.ptr->balls;
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_38);
		__tavr_tmp_39 = (i < __TAVR_ARRAY_LENGTH(__tavr_tmp_38));
		if(__tavr_tmp_39)
		{
			struct __tavr_ref_GameBall ball;
			__tavr_float dist_2;
			__tavr_int __tavr_tmp_40;
			struct __tavr_ref_GameBall __tavr_tmp_41;
			struct EngV2 __tavr_tmp_42;
			struct __tavr_ref_GameBall __tavr_tmp_43;
			__tavr_tmp_36 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_36);
			__tavr_tmp_37 = __tavr_tmp_36.ptr->game;
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_37);
			__tavr_tmp_38 = __tavr_tmp_37.ptr->balls;
			__tavr_tmp_40 = i;
			__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_38, __tavr_tmp_40);
			__tavr_tmp_39 = (__tavr_tmp_38.ptr[__tavr_tmp_40].ref == 0);
			if(__tavr_tmp_39)
			{
				goto __tavr_label_6;
			}
			__tavr_tmp_36 = (*__tavr_this);
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_36);
			__tavr_tmp_37 = __tavr_tmp_36.ptr->game;
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_37);
			__tavr_tmp_38 = __tavr_tmp_37.ptr->balls;
			__tavr_tmp_40 = i;
			__TAVR_ASSERT_ARRAY_INDEX(__tavr_tmp_38, __tavr_tmp_40);
			ball = __tavr_tmp_38.ptr[__tavr_tmp_40];
			__TAVR_INC_REF(ball);
			__tavr_tmp_41 = ball;
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_41);
			__tavr_tmp_42 = __tavr__EngV2___sub___EngV2_r(&(*pos), &__tavr_tmp_41.ptr->pos);
			dist_2 = __tavr__EngV2___length__2(&__tavr_tmp_42);
			__tavr_tmp_41 = ball;
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_41);
			__tavr_tmp_43 = ball;
			__TAVR_ASSERT_NULL_PTR(__tavr_tmp_43);
			__tavr_tmp_39 = (dist_2 < (__tavr_tmp_41.ptr->radius * __tavr_tmp_43.ptr->radius));
			if(__tavr_tmp_39)
			{
				__tavr_tmp_41 = ball;
				__TAVR_INC_REF(__tavr_tmp_41);
				__TAVR_DEC_REF(ball);
				return __tavr_tmp_41;
			}
			__TAVR_DEC_REF(ball);
		}
		else
		goto __tavr_label_7;
__tavr_label_6: ;
		{
			++i;
		}
		goto __tavr_label_5;
__tavr_label_7: ;
	}
	__tavr_tmp_44.ptr = 0;
	__tavr_tmp_44.ref = 0;
	return __tavr_tmp_44;
}
void __tavr__GameController___GameController___Game(struct __tavr_ref_GameController* __tavr_this, struct __tavr_ref_Game game)
{
	__tavr_this->ptr->__tavr_relax = 0;
	__tavr_this->ptr->game.ptr = 0;
	__tavr_this->ptr->game.ref = 0;
	__tavr_this->ptr->clickTimer = 150.f;
	__tavr_this->ptr->doubleClickTimer = 350.f;
	__tavr_this->ptr->lastClick = 0;
	__tavr_this->ptr->lastDown = 0;
	{
		struct __tavr_ref_GameController __tavr_tmp_45;
		struct __tavr_ref_Game* __tavr_tmp_46;
		__tavr_tmp_45 = (*__tavr_this);
		__TAVR_ASSERT_NULL_PTR(__tavr_tmp_45);
		__tavr_tmp_46 = &__tavr_tmp_45.ptr->game;
		__TAVR_DEC_REF((*__tavr_tmp_46));
		(*__tavr_tmp_46) = game;
		__TAVR_INC_REF((*__tavr_tmp_46));
		__TAVR_DEC_REF(game);
	}
}
void __tavr__GameController___destr_GameController(struct __tavr_ref_GameController* __tavr_this)
{
	__TAVR_DEC_REF(__tavr_this->ptr->game);
	switch (__tavr_this->ptr->__tavr_relax) {
		case 4:
			break;
		case 3:
			__TAVR_DEC_REF((*(struct __tavr_ref_EngMouse*)(__tavr_this->ptr->__tavr_stack+0)));
			__TAVR_DEC_REF((*(struct __tavr_ref_GameBall*)(__tavr_this->ptr->__tavr_stack+16)));
			break;
		case 1:
			break;
		case 2:
			break;
		default: if (__tavr_this->ptr->__tavr_relax != 0) __TAVR_UNKNOWN_RELAX_CONTEXT(); break;
	}
}
void __tavr__GameChangeGravity___GameChangeGravity___Game___bool___EngV2(struct __tavr_ref_GameChangeGravity* __tavr_this, struct __tavr_ref_Game game, __tavr_bool enable, struct EngV2 pos)
{
	__tavr_this->ptr->pos = pos;
	__tavr_this->ptr->enable = enable;
	__tavr_this->ptr->game = game;
	__TAVR_INC_REF(__tavr_this->ptr->game);
	__TAVR_DEC_REF(game);
}
void __tavr__GameChangeGravity___destr_GameChangeGravity(struct __tavr_ref_GameChangeGravity* __tavr_this)
{
	__TAVR_DEC_REF(__tavr_this->ptr->game);
}
