
#name TAVR_LOADER

program			-> decl_list;								<<< Program 						>>>

decl_list		-> decl *;									<<< NodeList 						>>>
decl			-> attrib_list func_header ";";				<<< NodeArg("NT(DECL_PROC)")		>>>
decl			-> attrib_list func_header code_block;		<<< NodeArg("NT(DECL_PROC)")		>>>
decl			-> $error "}";								<<< NodeError						>>>
decl			-> $error ";";								<<< NodeError						>>>

code_block		-> "{" stat_list "}";						<<< CodeBlock						>>>
code_stat		-> stat;									<<< CodeBlock						>>>

stat_list		-> stat *;									<<< NodeList 						>>>

// int a, b = 0, c;
stat 			-> expr decl_item_list ";";					<<< Node("NT(DECL_VAR)")			>>>

decl_item_list	-> decl_item % ",";							<<< NodeList						>>>
decl_item		-> $string | $string "=" expr;				<<< Node("NT(ARGUMENT)")			>>>
decl_item		-> $string "(" expr_list ")";				<<< Node("NT(DECL_VAR_CONSTR)")		>>>

// returns and etc.
stat			-> ";";										<<< Node							>>>
stat			-> expr ";";
stat			-> "return" ";";							<<< Node("NT(RETURN)")				>>>
stat			-> "return" expr ";";						<<< Node("NT(RETURN)")				>>>
stat			-> "return" $error;							<<< Error("ERR(TVR1002)")			>>>

stat			-> expr $error;								<<< Error("ERR(TVR1002)")			>>>
stat			-> $error ";";								<<< NodeError						>>>

// if
stat			-> "if" "(" expr ")" code_stat; shift("else") <<< StatIf						>>>
stat			-> "if" "(" expr ")" code_stat "else" code_stat; <<< StatIf						>>>
stat			-> "if" "(" expr $error;					<<< Error("ERR(TVR1003)")			>>>

// for
stat			-> "for" "(" for_stat ";" for_stat ";" for_stat ")" code_stat; <<< NodeArg("NT(FOR)") >>>
for_stat		-> expr;
for_stat		-> expr decl_item_list;						<<< Node("NT(DECL_VAR)")			>>>
for_stat		-> ;										<<< Node							>>>

// while
stat			-> "while" "(" expr ")" code_stat;			<<< Node("NT(WHILE)")				>>>
stat			-> "do" code_stat "while" "(" expr ")";		<<< Node("NT(DO_WHILE)")			>>>

// code block
stat			-> code_block;

// step
stat			-> step_type arg_name code_block;			<<< Step							>>>
stat			-> step_type $string ";";					<<< Step							>>>

// send
stat			-> "send" send_event_val send_to ";";		<<< NodeArg("NT(SEND)")				>>>
stat			-> "post" send_event_val send_to ";";		<<< NodeArg("NT(POST)")				>>>

send_event_val	-> ;										<<< Node							>>>
send_event_val	-> typename send_event_args;				<<< NodeArg("NT(ARGUMENT)")			>>>
send_event_args -> [ "(" expr_list ")" ];					<<< Node							>>>
send_to			-> [ "to" expr ];							<<< Node							>>>

// on
stat			-> "on" typename code_block;				<<< NodeArg("NT(ON)")				>>>
stat			-> "otherwise" code_stat;					<<< Node("NT(OTHERWISE)")			>>>

// += send
stat			-> expr "+=" "send" expr ";";				<<< Node("NT(REG_SEND)")			>>>
stat			-> expr "+=" expr ";";						<<< Node("NT(REG_SEND)")			>>>
stat			-> expr "+=" "post" expr ";";				<<< Node("NT(REG_POST)")			>>>
stat			-> expr "-=" expr ";";						<<< Node("NT(UNREG)")				>>>

// break, continue
stat			-> "break" ";";								<<< Node("NT(BREAK)")				>>>
stat			-> "continue" ";";							<<< Node("NT(CONTINUE)")			>>>
stat			-> "repeat" ";";							<<< Node("NT(REPEAT)")				>>>
stat			-> "goto" $string ";";						<<< Node("NT(GOTO)")				>>>

stat			-> "relax" ";";								<<< Node("NT(RELAX)")				>>>
stat			-> "relax" $string ";";						<<< Node("NT(RELAX)")				>>>
stat			-> "relax" "step" ";";						<<< Node("NT(RELAX_STEP)")			>>>

// FUNCTION HEADER
func_header		-> typename $string "(" arg_list ")";		<<< FuncHeader						>>>

arg_list		-> ["void"]; reduce("," ")")				<<< Node							>>>
arg_list		-> arg_type arg_name % ",";					<<< ArgList 						>>>
arg_type		-> "inout" typename;						<<< Node("ET(INOUT)")				>>>
arg_type		-> "out" typename;							<<< Node("ET(OUT)")					>>>
arg_type		-> typename;
arg_name		-> $string;
arg_name		-> ;										<<< ArgEmpty						>>>

// TYPENAME
typename		-> "void";									<<< Node("NT(NAME)", L"void")		>>>
typename		-> "bool";									<<< Node("NT(NAME)", L"bool")		>>>
typename		-> "char";									<<< Node("NT(NAME)", L"char")		>>>
typename		-> "string";								<<< Node("NT(NAME)", L"string")		>>>

typename		-> "byte";									<<< Node("NT(NAME)", L"byte")		>>>
typename		-> "word";									<<< Node("NT(NAME)", L"word")		>>>
typename		-> "int";									<<< Node("NT(NAME)", L"int")		>>>
typename		-> "uint";									<<< Node("NT(NAME)", L"uint")		>>>
typename		-> "long";									<<< Node("NT(NAME)", L"long")		>>>
typename		-> "ulong";									<<< Node("NT(NAME)", L"ulong")		>>>
typename		-> "float";									<<< Node("NT(NAME)", L"float")		>>>
typename		-> "double";								<<< Node("NT(NAME)", L"double")		>>>

typename		-> "global";								<<< Node("ET(GLOBAL)")				>>>
typename		-> $string;	reduce							<<< Node("NT(NAME)")				>>>
typename		-> typename "." $string;					<<< Node("NT(SUBNAME)")				>>>
typename		-> "typeof" expr;							<<< Node("ET(TYPEOF)")				>>>
typename		-> typename "[" "]";						<<< Node("ET(ARRAY)")				>>>
typename		-> "(" typename ")";

// STRUCT
decl			-> attrib_list "struct" $string "{" struct_decl_list "}"; <<< NodeArg("NT(STRUCT)")	>>>
struct_decl_list -> struct_decl *;							<<< NodeList						>>>

// struct variables
struct_decl		-> attrib_list typename struct_item_list ";"; <<< NodeArg("NT(DECL_MEMBER_VAR)") >>>
struct_item_list -> struct_item % ",";						<<< NodeList						>>>
struct_item		-> $string | $string "=" expr;				<<< Node("NT(ARGUMENT)")			>>>

// struct method
struct_decl		-> attrib_list func_header code_block;		<<<	NodeArg("NT(DECL_METHOD)")		>>>
struct_decl		-> attrib_list func_header ";";				<<<	NodeArg("NT(DECL_METHOD)")		>>>
attrib_list		-> attrib *;								<<< NodeList						>>>
attrib			-> "public";								<<< Node("NT(ATTRIB_PUBLIC)",		L"public")		>>>
attrib			-> "private";								<<< Node("NT(ATTRIB_PRIVATE)",		L"private")		>>>
attrib			-> "protected";								<<< Node("NT(ATTRIB_PROTECTED)",	L"protected")	>>>
attrib			-> "static";								<<< Node("NT(ATTRIB_STATIC)",		L"static")		>>>
attrib			-> "extern";								<<< Node("NT(ATTRIB_EXTERN)",		L"extern")		>>>

struct_decl		-> $error ";";								<<< NodeError						>>>

// constructor
struct_decl		-> attrib_list constr_header code_block;	<<< NodeArg("NT(DECL_CONSTR)")		>>>
struct_decl		-> attrib_list constr_header ";";			<<< NodeArg("NT(DECL_CONSTR)")		>>>
constr_header	-> $string "(" arg_list ")";				<<< FuncHeader						>>>

// operators
struct_decl		-> attrib_list operator_header code_block;	<<< NodeArg("NT(DECL_OPERATOR)")	>>>
struct_decl		-> attrib_list operator_header ";";			<<< NodeArg("NT(DECL_OPERATOR)")	>>>
operator_header -> "operator" "=" "(" arg_list ")";			<<< OperatorHeader(L"=")			>>>
operator_header	-> "operator" typename "(" arg_list ")";	<<< OperatorHeader(L"(T)")			>>>

// steps
struct_decl		-> step_type arg_name code_block;			<<< Step							>>>
struct_decl		-> step_type $string ";";					<<< Step							>>>

step_type		-> "step" | "loop" | "fixed" | "subauto";

// out
struct_decl		-> "out" typename $string ";";				<<< Node("NT(OUT)")					>>>

// AUTO
decl			-> attrib_list "auto" $string "{" struct_decl_list "}";	<<< NodeArg("NT(AUTO)")	>>>

// EVENT
decl			-> attrib_list "event" $string event_body;  <<< NodeArg("NT(EVENT)")			>>>
event_body		-> ["{" struct_decl_list "}"];				<<< Node							>>>

decl			-> ";";										<<< Node							>>>

right			"ref" "typeof" "sizeof";
right			"=" "+=" "-=" "*=" "/=" "%=" "<<=" ">>=" "&=" "|=" "^=";
right			"?";
left			"||";
left			"&&";
left			"<" "<=" ">" ">=" "==" "!=";
left			"<<" ">>";
left			"&" "|" "^";
left			"+" "-";
left			"*" "/" "%";
right			unar;
left			"++" "--";
left			"[" "(";
left			".";

expr			-> $string;									<<< Node("NT(NAME)")				>>>
expr			-> expr "." $string;						<<< Node("NT(SUBNAME)")				>>>
expr			-> expr "." "auto";							<<< Node("NT(SUBNAME)", L"auto")	>>>
expr			-> expr "." $error;							<<< Error("ERR(TVR1006)")			>>>

expr			-> expr "=" expr;							<<< Node("ET(ASSIGN)")				>>>

// ARITHMETIC OPERATIONS

/*
expr			-> expr "+=" expr;							<<< Node("ET(ASSIGN_ADD)")			>>>
expr			-> expr "-=" expr;							<<< Node("ET(ASSIGN_SUB)")			>>>
expr			-> expr "*=" expr;							<<< Node("ET(ASSIGN_MUL)")			>>>
expr			-> expr "/=" expr;							<<< Node("ET(ASSIGN_DIV)")			>>>
expr			-> expr "%=" expr;							<<< Node("ET(ASSIGN_MOD)")			>>>

expr			-> expr "<<=" expr;							<<< Node("ET(ASSING_SHL)")			>>>
expr			-> expr ">>=" expr;							<<< Node("ET(ASSING_SHR)")			>>>

expr			-> expr "&=" expr;							<<< Node("ET(ASSING_BIT_AND)")		>>>
expr			-> expr "|=" expr;							<<< Node("ET(ASSING_BIT_OR)")		>>>
expr			-> expr "^=" expr;							<<< Node("ET(ASSING_BIT_XOR)")		>>>

expr			-> expr "&" expr;							<<< Node("ET(BIT_AND)")				>>>
expr			-> expr "|" expr;							<<< Node("ET(BIT_OR)")				>>>
expr			-> expr "^" expr;							<<< Node("ET(BIT_XOR)")				>>>

expr			-> expr "<<" expr;							<<< Node("ET(SHL)")					>>>
expr			-> expr ">>" expr;							<<< Node("ET(SHR)")					>>>
/**/
expr			-> expr "+" expr;							<<< Node("ET(ADD)")					>>>
expr			-> expr "-" expr;							<<< Node("ET(SUB)")					>>>
expr			-> expr "*" expr;							<<< Node("ET(MUL)")					>>>
expr			-> expr "/" expr;							<<< Node("ET(DIV)")					>>>
expr			-> expr "%" expr;							<<< Node("ET(MOD)")					>>>

expr			-> expr "||" expr;							<<< Node("ET(LOG_OR)") 				>>>
expr			-> expr "&&" expr;							<<< Node("ET(LOG_AND)")				>>>
expr			-> expr "==" expr;							<<< Node("ET(EQ)")     				>>>
expr			-> expr "!=" expr;							<<< Node("ET(NOT_EQ)") 				>>>
expr			-> expr "<"  expr;							<<< Node("ET(LESS)")   				>>>
expr			-> expr "<=" expr;							<<< Node("ET(LESS_EQ)")				>>>
expr			-> expr ">"  expr;							<<< Node("ET(GREATER)")  			>>>
expr			-> expr ">=" expr;							<<< Node("ET(GREATER_EQ)")			>>>

expr			-> "!" expr; prior(unar)					<<< Node("ET(LOG_NOT)")				>>>
expr			-> "~" expr; prior(unar)					<<< Node("ET(BIT_NOT)")				>>>
expr			-> "+" expr; prior(unar)					<<< Node("ET(POS)")					>>>
expr			-> "-" expr; prior(unar)					<<< Node("ET(NEG)")	 				>>>

expr			-> "++" expr;								<<< Node("ET(PRE_INC)")				>>>
expr			-> "--" expr;								<<< Node("ET(PRE_DEC)")				>>>
expr			-> expr "++";								<<< Node("ET(POST_INC)") 			>>>
expr			-> expr "--";								<<< Node("ET(POST_DEC)") 			>>>

expr			-> "true";									<<< Node("ET(BOOLEAN)",	L"true")	>>>
expr			-> "false";									<<< Node("ET(BOOLEAN)",	L"false")	>>>
expr			-> "null";									<<< Node("ET(NULL)")				>>>
expr			-> "this";									<<< Node("ET(THIS)")				>>>
expr			-> "event";									<<< Node("ET(EVENT)")				>>>
expr			-> $integer;								<<< Node("ET(INT)")					>>>
expr			-> $float;									<<< Node("ET(FLOAT)")				>>>
expr			-> $double;									<<< Node("ET(DOUBLE)")				>>>
expr			-> $char;									<<< Node("ET(CHAR)")				>>>
expr			-> $literal;								<<< Node("ET(STRING)")				>>>

expr			-> "auto";									<<< Node("NT(NAME)", L"auto")		>>>

expr			-> typename; reduce("." "[" ")")
expr			-> "sizeof" expr;							<<< Node("ET(SIZEOF)")				>>>

expr			-> "new" typename "(" expr_list ")";		<<< Node("ET(NEW_AUTO)")			>>>
expr			-> "new" typename "[" expr "]";				<<< Node("ET(NEW_ARRAY)")			>>>

expr			-> "(" expr ")" expr; prior(unar)			<<< Node("ET(TYPE_CAST)")			>>>
expr			-> expr "?" expr ":" expr;						<<< Node("ET(IF)")					>>>

expr			-> "(" expr ")"; prior(unar) shift($string)
expr			-> expr "(" expr_list ")"; 					<<< Node("ET(CALL)")				>>>
expr			-> expr "[" expr_list "]";					<<< Node("ET(ARRAY)")				>>>

expr_list		-> expr % ",";								<<< NodeList 						>>>
expr_list		-> ;										<<< NodeList 						>>>

//*				: PNODE
decl,			decl_list,
decl_item,		decl_item_list,
stat,			stat_list,
func_header,	constr_header,		operator_header,
code_block,		code_stat,
arg_type,		arg_list,
typename,		expr,				expr_list,
struct_decl,	struct_decl_list,
struct_item_list, struct_item,
attrib,			attrib_list,
send_event_args, send_event_val,	send_to,
event_body,
for_stat		: PNODE

"this"			|
"step"			| "loop"	| "fixed"	| "subauto"	|
$string 		| $integer	| $float	| $double	|
$char			|
$literal		<<< StrVal >>>

arg_name,
"this",
step_type, "step", "loop", "fixed", "subauto",
$string,
$integer, $float, $double,
$char,
$literal		: STRVAL

skip	 		= \s
cline			= //
cbegin			= /{*}
cend			= {*}/

$string			= {\S^\y\d@}{\S^\y@}*
$integer		= \d+
$float			= (\d+.\d*|\d*.\d+)[{eE}[{+\-}]\d+]f
$double			= (\d+.\d*|\d*.\d+)[{eE}[{+\-}]\d+]
$char			= '(\\{^\n}|{^\\\n\'})'
$literal		= "(\\{^\n}|{^\\\n\"})*"

msg {
	TVR1001		= "{token}: unexpected symbol";
	TVR1002		= "missing ';' before symbol {token}";
	TVR1003		= "missing ')' before symbol {token}";
	TVR1004		= "{token}: unexpected symbol, argument name expected";
	TVR1005		= "{token}: unexpected symbol, argument type expected";
	TVR1006		= "{token}: unexpected symbol, element subname expected";

	TVR1007		= "unexpected value in type declaration";
	TVR1008		= "'{name}': undeclared identifier";
	TVR1009		= "unable to open file for reading";
	TVR1010		= "unable to open file for writing";
	TVR1011		= "type expected for function argument at position {number}";
	TVR1012		= "type expected as a result type of the function '{name}'";
	TVR1013		= "'{name}': term does not evaluate to a function";
	TVR1014		= "'=': left operand must be l-value";
	TVR1015		= "'{name}': invalid variable type";
	TVR1016		= "'{name}': redefinition";
	TVR1017		= "integral type expected as an array size or index";	// TODO: need more info: array of what type is? what's found?

	TVR1018		= "'[]': index expected";
	TVR1019		= "'[]': array types do not support multiple indices";
	TVR1020		= "'{name}': integral type expected";
	TVR1021		= "'{name}': operand must be l-value";
	TVR1022		= "'{name}': illegal use of this type as an expression";
	TVR1023		= "'{op}': illegal operand type '{name}'";
	TVR1024		= "'{op}': illegal, '{name}' and '{name2}' are incompatible types";
	TVR1025		= "'{name}': type expected";
	TVR1026		= "'{name2}': left of '{name}' must have struct/auto/namespace type";
	TVR1027		= "'{name}': is not a member of the '{name2}'";

	TVR1028		= "'{name}': recursion found in value type member declaration";
	TVR1029		= "'{name}': global functions do not have 'this' pointers";
	TVR1030		= "'{name}': function not found";
	TVR1031		= "'{name}': illegal, only 'struct' types could be constructed in such way";
	TVR1032		= "'{name2}': '{name}' condition must have boolean type";
	TVR1033		= "'{name}': illegal statement";
	TVR1034		= "'goto': reference to unknown step '{name}'";
	TVR1035		= "'{name}': 'auto' or 'event' type expected for operator 'new'";
	TVR1036		= "'{name}': redefinition, function differs only by 'inout' or 'out' argument type";
	TVR1037		= "'{name}': redefinition, function differs only by result type '{name2}'";

	TVR1038		= "'[]': unexpected value in array type declaration";
	TVR1039		= "'{name}': invalid constructor name '{name2}'";
	TVR1040		= "'{name}': has too few parameters";
	TVR1041		= "'{name}': has too many parameters";
	TVR1042		= "'{name}': illegal, copy constructor should take 'inout' parameter, otherwise it causes infinite recursion";
	TVR1043		= "'{name}': entry point function not found";
	TVR1044		= "'{name}': invalid entry point function result type";
	TVR1045		= "'{name}': ambiguous call to overloaded function";
	TVR1046		= "'{name}': variable initialization is skipped by 'goto' statement";
	TVR1047		= "'{name}': illegal, implementation found for 'extern' function";

	TVR1048		= "'{name}': illegal, implementation could be skipped only for 'extern' functions";
	TVR1049		= "'{name}': more than one familiar attribute specified";
	TVR1050		= "'{name}': unable to call this method in a static context";
	TVR1051		= "'{name}': unknown character escape sequence";
	TVR1052		= "operator '=' could be declared only for 'struct' types";
	TVR1053		= "'{name}': invalid 'typeof' value type";
	TVR1054		= "'return': illegal statement in 'auto' method declaration";
	TVR1055		= "'{name}': recursion found in relax stack variable declaration";
	TVR1056		= "'{name}': invalid call of operator 'new' for static type";
	TVR1057		= "'{name}': illegal '{type}' declaration for event type";

	TVR1058		= "'{name}': event expected in send or post instruction";
	TVR1059		= "'{name}': invalid destination type in send or post instruction";
	TVR1060		= "'{name}': destination type does not support send or post instruction";
	TVR1061		= "'send': illegal, trying to send a synchronous event to itself";
	TVR1062		= "'post': illegal, trying to send an event to itself in a static context";
	TVR1063		= "'{name}': event expected in 'on' block declaration";
	TVR1064		= "'event': illegal, value out of 'on' block context";
	TVR1065		= "'{name}': event expected in 'out' action declaration";
	TVR1066		= "'{name}': illegal, 'out' subscribe list expected";
	TVR1067		= "'{name}': illegal, 'auto' type expected for subscriber list";

	TVR_SEEDECL_INFO	= "see declaration of '{name}'";
	TVR_AMBIGUITY_INFO	= "could be '{name}'";
	TVR_GOTO_INFO		= "see 'goto' statement";

	TOKEN_INFO		= "'{token}'";
	TOKEN_INFO_EOF	= "'<end of file>'";
}
