
/*************************************************************************/
/* TAVR_LOADER_IMPL.H                                                E13 */
/*                                                                       */
/* .                                                                     */
/*************************************************************************/

#ifndef TAVR_LOADER_IMPL_H
#define TAVR_LOADER_IMPL_H

#ifndef TOKEN_EOF
#define TOKEN_EOF		-1
#endif

#ifndef TOKEN_ERROR
#define TOKEN_ERROR		-2
#endif

namespace ecg {

class TAVR_LOADER;

/*************************************************************************/
/* class TAVR_LOADER_IMPL                                                */
/*                                                                       */
/*************************************************************************/
class TAVR_LOADER_IMPL {
public:
	enum {
		STATE_COUNT		= 320,
		TERM_COUNT		= 105,
		NONTERM_COUNT	= 31,
		RULE_COUNT		= 172,
	};

	//enum TERMINALS {
	//		TOKEN_T_NAME_1,					// ";"
	//		TOKEN_T_NAME_2,					// "}"
	//		TOKEN_T_NAME_3,					// "{"
	//		TOKEN_T_NAME_4,					// ","
	//		TOKEN_T_STRING,					// $string
	//		TOKEN_T_NAME_5,					// "="
	//		TOKEN_T_NAME_6,					// "("
	//		TOKEN_T_NAME_7,					// ")"
	//		TOKEN_T_RETURN,					// "return"
	//		TOKEN_T_IF,						// "if"
	//		TOKEN_T_ELSE,					// "else"
	//		TOKEN_T_FOR,					// "for"
	//		TOKEN_T_WHILE,					// "while"
	//		TOKEN_T_DO,						// "do"
	//		TOKEN_T_SEND,					// "send"
	//		TOKEN_T_POST,					// "post"
	//		TOKEN_T_TO,						// "to"
	//		TOKEN_T_ON,						// "on"
	//		TOKEN_T_OTHERWISE,				// "otherwise"
	//		TOKEN_T_NAME_8,					// "+="
	//		TOKEN_T_NAME_9,					// "-="
	//		TOKEN_T_BREAK,					// "break"
	//		TOKEN_T_CONTINUE,				// "continue"
	//		TOKEN_T_REPEAT,					// "repeat"
	//		TOKEN_T_GOTO,					// "goto"
	//		TOKEN_T_RELAX,					// "relax"
	//		TOKEN_T_STEP,					// "step"
	//		TOKEN_T_VOID,					// "void"
	//		TOKEN_T_INOUT,					// "inout"
	//		TOKEN_T_OUT,					// "out"
	//		TOKEN_T_BOOL,					// "bool"
	//		TOKEN_T_CHAR,					// "char"
	//		TOKEN_T_NAME_10,				// "string"
	//		TOKEN_T_BYTE,					// "byte"
	//		TOKEN_T_WORD,					// "word"
	//		TOKEN_T_INT,					// "int"
	//		TOKEN_T_UINT,					// "uint"
	//		TOKEN_T_LONG,					// "long"
	//		TOKEN_T_ULONG,					// "ulong"
	//		TOKEN_T_FLOAT,					// "float"
	//		TOKEN_T_DOUBLE,					// "double"
	//		TOKEN_T_GLOBAL,					// "global"
	//		TOKEN_T_NAME_11,				// "."
	//		TOKEN_T_TYPEOF,					// "typeof"
	//		TOKEN_T_NAME_12,				// "["
	//		TOKEN_T_NAME_13,				// "]"
	//		TOKEN_T_STRUCT,					// "struct"
	//		TOKEN_T_PUBLIC,					// "public"
	//		TOKEN_T_PRIVATE,				// "private"
	//		TOKEN_T_PROTECTED,				// "protected"
	//		TOKEN_T_STATIC,					// "static"
	//		TOKEN_T_EXTERN,					// "extern"
	//		TOKEN_T_OPERATOR,				// "operator"
	//		TOKEN_T_LOOP,					// "loop"
	//		TOKEN_T_FIXED,					// "fixed"
	//		TOKEN_T_SUBAUTO,				// "subauto"
	//		TOKEN_T_AUTO,					// "auto"
	//		TOKEN_T_EVENT,					// "event"
	//		TOKEN_T_REF,					// "ref"
	//		TOKEN_T_SIZEOF,					// "sizeof"
	//		TOKEN_T_NAME_14,				// "*="
	//		TOKEN_T_NAME_15,				// "/="
	//		TOKEN_T_NAME_16,				// "%="
	//		TOKEN_T_NAME_17,				// "<<="
	//		TOKEN_T_NAME_18,				// ">>="
	//		TOKEN_T_NAME_19,				// "&="
	//		TOKEN_T_NAME_20,				// "|="
	//		TOKEN_T_NAME_21,				// "^="
	//		TOKEN_T_NAME_22,				// "?"
	//		TOKEN_T_NAME_23,				// "||"
	//		TOKEN_T_NAME_24,				// "&&"
	//		TOKEN_T_NAME_25,				// "<"
	//		TOKEN_T_NAME_26,				// "<="
	//		TOKEN_T_NAME_27,				// ">"
	//		TOKEN_T_NAME_28,				// ">="
	//		TOKEN_T_NAME_29,				// "=="
	//		TOKEN_T_NAME_30,				// "!="
	//		TOKEN_T_NAME_31,				// "<<"
	//		TOKEN_T_NAME_32,				// ">>"
	//		TOKEN_T_NAME_33,				// "&"
	//		TOKEN_T_NAME_34,				// "|"
	//		TOKEN_T_NAME_35,				// "^"
	//		TOKEN_T_NAME_36,				// "+"
	//		TOKEN_T_NAME_37,				// "-"
	//		TOKEN_T_NAME_38,				// "*"
	//		TOKEN_T_NAME_39,				// "/"
	//		TOKEN_T_NAME_40,				// "%"
	//		TOKEN_T_NAME_41,				// "++"
	//		TOKEN_T_NAME_42,				// "--"
	//		TOKEN_T_NAME_43,				// "!"
	//		TOKEN_T_NAME_44,				// "~"
	//		TOKEN_T_TRUE,					// "true"
	//		TOKEN_T_FALSE,					// "false"
	//		TOKEN_T_NULL,					// "null"
	//		TOKEN_T_THIS,					// "this"
	//		TOKEN_T_INTEGER,				// $integer
	//		TOKEN_T_NAME_45,				// $float
	//		TOKEN_T_NAME_46,				// $double
	//		TOKEN_T_NAME_47,				// $char
	//		TOKEN_T_LITERAL,				// $literal
	//		TOKEN_T_NEW,					// "new"
	//		TOKEN_T_NAME_48,				// ":"
	//		TOKEN_T_CLINE,					// $cline
	//		TOKEN_T_CBEGIN,					// $cbegin
	//		TOKEN_T_CEND,					// $cend
	//};

	enum NONTERMINALS {
		TOKEN_NT_DECL_LIST,			// decl_list
		TOKEN_NT_PROGRAM,			// program
		TOKEN_NT_DECL,				// decl
		TOKEN_NT_ATTRIB_LIST,		// attrib_list
		TOKEN_NT_FUNC_HEADER,		// func_header
		TOKEN_NT_CODE_BLOCK,		// code_block
		TOKEN_NT_STAT_LIST,			// stat_list
		TOKEN_NT_STAT,				// stat
		TOKEN_NT_CODE_STAT,			// code_stat
		TOKEN_NT_EXPR,				// expr
		TOKEN_NT_DECL_ITEM_LIST,	// decl_item_list
		TOKEN_NT_DECL_ITEM,			// decl_item
		TOKEN_NT_EXPR_LIST,			// expr_list
		TOKEN_NT_FOR_STAT,			// for_stat
		TOKEN_NT_STEP_TYPE,			// step_type
		TOKEN_NT_ARG_NAME,			// arg_name
		TOKEN_NT_SEND_EVENT_VAL,	// send_event_val
		TOKEN_NT_SEND_TO,			// send_to
		TOKEN_NT_TYPENAME,			// typename
		TOKEN_NT_SEND_EVENT_ARGS,	// send_event_args
		TOKEN_NT_ARG_LIST,			// arg_list
		TOKEN_NT_ARG_TYPE,			// arg_type
		TOKEN_NT_STRUCT_DECL_LIST,	// struct_decl_list
		TOKEN_NT_STRUCT_DECL,		// struct_decl
		TOKEN_NT_STRUCT_ITEM_LIST,	// struct_item_list
		TOKEN_NT_STRUCT_ITEM,		// struct_item
		TOKEN_NT_ATTRIB,			// attrib
		TOKEN_NT_CONSTR_HEADER,		// constr_header
		TOKEN_NT_OPERATOR_HEADER,	// operator_header
		TOKEN_NT_EVENT_BODY,		// event_body
		TOKEN_NT_PROGRAM_1,			// program_1
	};

	union VALUE_T;
	typedef TAVR_LOADER IMPL_T;

public:
						TAVR_LOADER_IMPL (void);
	void				Compile				(void);

protected:
	void				intPushString		(void);
	void				intPushEmptyString	(void);
	void				intCreateStringArray(void);
	void				intAppendStringArray(void);

	template <class T> void intCreatePtrArray(void);
	template <class T> void intAppendPtrArray(void);
	template <class T> void intCreateValArray(void);
	template <class T> void intAppendValArray(void);

protected:
	void				ArgEmpty_Impl0		(void);
	void				ArgList_Impl0		(void);
	void				ArgList_Impl1		(void);
	void				CodeBlock_Impl0		(void);
	void				Error_Impl0		(void);
	void				Error_Impl1		(void);
	void				Error_Impl2		(void);
	void				Error_Impl3		(void);
	void				FuncHeader_Impl0		(void);
	void				FuncHeader_Impl1		(void);
	void				NodeArg_Impl0		(void);
	void				NodeArg_Impl1		(void);
	void				NodeArg_Impl10		(void);
	void				NodeArg_Impl11		(void);
	void				NodeArg_Impl12		(void);
	void				NodeArg_Impl13		(void);
	void				NodeArg_Impl14		(void);
	void				NodeArg_Impl15		(void);
	void				NodeArg_Impl16		(void);
	void				NodeArg_Impl2		(void);
	void				NodeArg_Impl3		(void);
	void				NodeArg_Impl4		(void);
	void				NodeArg_Impl5		(void);
	void				NodeArg_Impl6		(void);
	void				NodeArg_Impl7		(void);
	void				NodeArg_Impl8		(void);
	void				NodeArg_Impl9		(void);
	void				NodeError_Impl0		(void);
	void				NodeList_Impl0		(void);
	void				NodeList_Impl1		(void);
	void				NodeList_Impl2		(void);
	void				Node_Impl0		(void);
	void				Node_Impl1		(void);
	void				Node_Impl10		(void);
	void				Node_Impl11		(void);
	void				Node_Impl12		(void);
	void				Node_Impl13		(void);
	void				Node_Impl14		(void);
	void				Node_Impl15		(void);
	void				Node_Impl16		(void);
	void				Node_Impl17		(void);
	void				Node_Impl18		(void);
	void				Node_Impl19		(void);
	void				Node_Impl2		(void);
	void				Node_Impl20		(void);
	void				Node_Impl21		(void);
	void				Node_Impl22		(void);
	void				Node_Impl23		(void);
	void				Node_Impl24		(void);
	void				Node_Impl25		(void);
	void				Node_Impl26		(void);
	void				Node_Impl27		(void);
	void				Node_Impl28		(void);
	void				Node_Impl29		(void);
	void				Node_Impl3		(void);
	void				Node_Impl30		(void);
	void				Node_Impl31		(void);
	void				Node_Impl32		(void);
	void				Node_Impl33		(void);
	void				Node_Impl34		(void);
	void				Node_Impl35		(void);
	void				Node_Impl36		(void);
	void				Node_Impl37		(void);
	void				Node_Impl38		(void);
	void				Node_Impl39		(void);
	void				Node_Impl4		(void);
	void				Node_Impl40		(void);
	void				Node_Impl41		(void);
	void				Node_Impl42		(void);
	void				Node_Impl43		(void);
	void				Node_Impl44		(void);
	void				Node_Impl45		(void);
	void				Node_Impl46		(void);
	void				Node_Impl47		(void);
	void				Node_Impl48		(void);
	void				Node_Impl49		(void);
	void				Node_Impl5		(void);
	void				Node_Impl50		(void);
	void				Node_Impl51		(void);
	void				Node_Impl52		(void);
	void				Node_Impl53		(void);
	void				Node_Impl54		(void);
	void				Node_Impl55		(void);
	void				Node_Impl56		(void);
	void				Node_Impl57		(void);
	void				Node_Impl58		(void);
	void				Node_Impl59		(void);
	void				Node_Impl6		(void);
	void				Node_Impl60		(void);
	void				Node_Impl61		(void);
	void				Node_Impl62		(void);
	void				Node_Impl63		(void);
	void				Node_Impl64		(void);
	void				Node_Impl65		(void);
	void				Node_Impl66		(void);
	void				Node_Impl67		(void);
	void				Node_Impl68		(void);
	void				Node_Impl69		(void);
	void				Node_Impl7		(void);
	void				Node_Impl70		(void);
	void				Node_Impl71		(void);
	void				Node_Impl72		(void);
	void				Node_Impl73		(void);
	void				Node_Impl74		(void);
	void				Node_Impl75		(void);
	void				Node_Impl76		(void);
	void				Node_Impl77		(void);
	void				Node_Impl78		(void);
	void				Node_Impl79		(void);
	void				Node_Impl8		(void);
	void				Node_Impl80		(void);
	void				Node_Impl81		(void);
	void				Node_Impl82		(void);
	void				Node_Impl83		(void);
	void				Node_Impl84		(void);
	void				Node_Impl85		(void);
	void				Node_Impl86		(void);
	void				Node_Impl9		(void);
	void				OperatorHeader_Impl0		(void);
	void				OperatorHeader_Impl1		(void);
	void				Program_Impl0		(void);
	void				StatIf_Impl0		(void);
	void				StatIf_Impl1		(void);
	void				Step_Impl0		(void);
	void				Step_Impl1		(void);
	void				StrVal_Impl0		(void);

protected:
	COMPILER_STATE_F	compilerState;
	PTR_STACK			pstack;
	std::stack<std::string> sstack;
	RAW_STACK			vstack;

private:
	IMPL_T &			Impl			(void);

private:
	typedef AUTO_CONFIG<STATE_COUNT, TERM_COUNT, NONTERM_COUNT, RULE_COUNT> CONFIG_T;
	typedef AUTO<IMPL_T, CONFIG_T> AUTO_T;
	friend AUTO_T;

	typedef AUTO_T::ACTION		ACTION;
	typedef AUTO_T::ACTION_PROC	ACTION_PROC;
	typedef AUTO_T::PRODUCTION	PRODUCTION;

	static const ACTION			actionTable			[STATE_COUNT][TERM_COUNT];
	static const ACTION			actionTableEof		[STATE_COUNT];
	static const ACTION			actionTableError	[STATE_COUNT];
	static const int			productionTable		[STATE_COUNT][NONTERM_COUNT];
	static const PRODUCTION		procTableProduction	[RULE_COUNT];
	static const ACTION_PROC	procTableTerm		[TERM_COUNT];
	static const ACTION_PROC	procTableNonterm	[NONTERM_COUNT];

	AUTO_T				compilerAuto;
};

} // namespace ecg

#endif // TAVR_LOADER_IMPL_H

