
/*************************************************************************/
/* LEX                                                               E13 */
/*                                                                       */
/* generated by ecg                                                      */
/*************************************************************************/

#ifndef TAVR_LOADER_LEX_H
#define TAVR_LOADER_LEX_H

#ifndef TOKEN_EOF
#define TOKEN_EOF		-1
#endif

#ifndef TOKEN_ERROR
#define TOKEN_ERROR		-2
#endif

namespace ecg {

class TAVR_LOADER_LEX {
public:
	enum TERMINALS {
		TOKEN_T_NAME_1,    // ';'
		TOKEN_T_NAME_2,    // '}'
		TOKEN_T_NAME_3,    // '{'
		TOKEN_T_NAME_4,    // ','
		TOKEN_T_STRING,    // '$string'
		TOKEN_T_NAME_5,    // '='
		TOKEN_T_NAME_6,    // '('
		TOKEN_T_NAME_7,    // ')'
		TOKEN_T_RETURN,    // 'return'
		TOKEN_T_IF,        // 'if'
		TOKEN_T_ELSE,      // 'else'
		TOKEN_T_FOR,       // 'for'
		TOKEN_T_WHILE,     // 'while'
		TOKEN_T_DO,        // 'do'
		TOKEN_T_SEND,      // 'send'
		TOKEN_T_POST,      // 'post'
		TOKEN_T_TO,        // 'to'
		TOKEN_T_ON,        // 'on'
		TOKEN_T_OTHERWISE, // 'otherwise'
		TOKEN_T_NAME_8,    // '+='
		TOKEN_T_NAME_9,    // '-='
		TOKEN_T_BREAK,     // 'break'
		TOKEN_T_CONTINUE,  // 'continue'
		TOKEN_T_REPEAT,    // 'repeat'
		TOKEN_T_GOTO,      // 'goto'
		TOKEN_T_RELAX,     // 'relax'
		TOKEN_T_STEP,      // 'step'
		TOKEN_T_VOID,      // 'void'
		TOKEN_T_INOUT,     // 'inout'
		TOKEN_T_OUT,       // 'out'
		TOKEN_T_BOOL,      // 'bool'
		TOKEN_T_CHAR,      // 'char'
		TOKEN_T_NAME_10,   // 'string'
		TOKEN_T_BYTE,      // 'byte'
		TOKEN_T_WORD,      // 'word'
		TOKEN_T_INT,       // 'int'
		TOKEN_T_UINT,      // 'uint'
		TOKEN_T_LONG,      // 'long'
		TOKEN_T_ULONG,     // 'ulong'
		TOKEN_T_FLOAT,     // 'float'
		TOKEN_T_DOUBLE,    // 'double'
		TOKEN_T_GLOBAL,    // 'global'
		TOKEN_T_NAME_11,   // '.'
		TOKEN_T_TYPEOF,    // 'typeof'
		TOKEN_T_NAME_12,   // '['
		TOKEN_T_NAME_13,   // ']'
		TOKEN_T_STRUCT,    // 'struct'
		TOKEN_T_PUBLIC,    // 'public'
		TOKEN_T_PRIVATE,   // 'private'
		TOKEN_T_PROTECTED, // 'protected'
		TOKEN_T_STATIC,    // 'static'
		TOKEN_T_EXTERN,    // 'extern'
		TOKEN_T_OPERATOR,  // 'operator'
		TOKEN_T_LOOP,      // 'loop'
		TOKEN_T_FIXED,     // 'fixed'
		TOKEN_T_SUBAUTO,   // 'subauto'
		TOKEN_T_AUTO,      // 'auto'
		TOKEN_T_EVENT,     // 'event'
		TOKEN_T_REF,       // 'ref'
		TOKEN_T_SIZEOF,    // 'sizeof'
		TOKEN_T_NAME_14,   // '*='
		TOKEN_T_NAME_15,   // '/='
		TOKEN_T_NAME_16,   // '%='
		TOKEN_T_NAME_17,   // '<<='
		TOKEN_T_NAME_18,   // '>>='
		TOKEN_T_NAME_19,   // '&='
		TOKEN_T_NAME_20,   // '|='
		TOKEN_T_NAME_21,   // '^='
		TOKEN_T_NAME_22,   // '?'
		TOKEN_T_NAME_23,   // '||'
		TOKEN_T_NAME_24,   // '&&'
		TOKEN_T_NAME_25,   // '<'
		TOKEN_T_NAME_26,   // '<='
		TOKEN_T_NAME_27,   // '>'
		TOKEN_T_NAME_28,   // '>='
		TOKEN_T_NAME_29,   // '=='
		TOKEN_T_NAME_30,   // '!='
		TOKEN_T_NAME_31,   // '<<'
		TOKEN_T_NAME_32,   // '>>'
		TOKEN_T_NAME_33,   // '&'
		TOKEN_T_NAME_34,   // '|'
		TOKEN_T_NAME_35,   // '^'
		TOKEN_T_NAME_36,   // '+'
		TOKEN_T_NAME_37,   // '-'
		TOKEN_T_NAME_38,   // '*'
		TOKEN_T_NAME_39,   // '/'
		TOKEN_T_NAME_40,   // '%'
		TOKEN_T_NAME_41,   // '++'
		TOKEN_T_NAME_42,   // '--'
		TOKEN_T_NAME_43,   // '!'
		TOKEN_T_NAME_44,   // '~'
		TOKEN_T_TRUE,      // 'true'
		TOKEN_T_FALSE,     // 'false'
		TOKEN_T_NULL,      // 'null'
		TOKEN_T_THIS,      // 'this'
		TOKEN_T_INTEGER,   // '$integer'
		TOKEN_T_NAME_45,   // '$float'
		TOKEN_T_NAME_46,   // '$double'
		TOKEN_T_NAME_47,   // '$char'
		TOKEN_T_LITERAL,   // '$literal'
		TOKEN_T_NEW,       // 'new'
		TOKEN_T_NAME_48,   // ':'
		TOKEN_T_CLINE,     // '$cline'
		TOKEN_T_CBEGIN,    // '$cbegin'
		TOKEN_T_CEND,      // '$cend'
	};

	enum {
		TOKEN_COMMENT_LINE			= TOKEN_T_CLINE,
		TOKEN_COMMENT_BLOCK_BEGIN	= TOKEN_T_CBEGIN,
		TOKEN_COMMENT_BLOCK_END		= TOKEN_T_CEND,
	};

	typedef unsigned char CHAR_T;

public:
	TAVR_LOADER_LEX(void);

	int					Token			(void) const { return token; }
	const std::string & TokenValue		(void) const { return value; }
	int					Line			(void) const { return line + 1; }
	int 				NextToken		(void);

	enum PRESET {
		PRESET_DEFAULT,
		PRESET_COMMENT,
	};

	void				SetPreset		(PRESET preset);
	void				PushPreset		(PRESET preset);
	void				PopPreset		(void);
	PRESET				GetPreset		(void) const;

protected:
	virtual void		Unexpected		(char ch);
	virtual void		Unexpected		(const std::string & val = std::string()); // empty string means end of file

private:
	bool				PopChar		(CHAR_T & ch);
	void				PushChar	(CHAR_T ch);

protected:
	int					token;
	std::string			value;
	int					line;

private:
	// enables unget any count of chars
	std::stack<CHAR_T>	charStack;

	// preset data
	std::stack<PRESET>	presetsStack;

	static const int 	isSkip_default[];
	static const int 	final_default[];
	static const int 	productive_default[];
	static const int 	isSkip_comment[];
	static const int 	final_comment[];
	static const int 	productive_comment[];

	// parsing data
	const int *			final;
	const int *			isSkip;
	const int *			productive;

	static const int	table[][57];
	static const int	terminal[];
};

} // namespace ecg

#endif // TAVR_LOADER_LEX_H
