
/*************************************************************************/
/* MSG                                                               E13 */
/*                                                                       */
/* .                                                                     */
/*************************************************************************/

#include "stdafx.h"
#include "tavr_loader.h"

namespace ecg {

/*************************************************************************/
/* TAVR_LOADER_MSG::messageTable
/* 
/*************************************************************************/
const MSG_HOLDER TAVR_LOADER_messageTable[] = {
	{ "TOKEN_INFO", "'{token}'",  },
	{ "TOKEN_INFO_EOF", "'<end of file>'",  },
	{ "TVR1001", "{token}: unexpected symbol",  },
	{ "TVR1002", "missing ';' before symbol {token}",  },
	{ "TVR1003", "missing ')' before symbol {token}",  },
	{ "TVR1004", "{token}: unexpected symbol, argument name expected",  },
	{ "TVR1005", "{token}: unexpected symbol, argument type expected",  },
	{ "TVR1006", "{token}: unexpected symbol, element subname expected",  },
	{ "TVR1007", "unexpected value in type declaration",  },
	{ "TVR1008", "'{name}': undeclared identifier",  },
	{ "TVR1009", "unable to open file for reading",  },
	{ "TVR1010", "unable to open file for writing",  },
	{ "TVR1011", "type expected for function argument at position {number}",  },
	{ "TVR1012", "type expected as a result type of the function '{name}'",  },
	{ "TVR1013", "'{name}': term does not evaluate to a function",  },
	{ "TVR1014", "'=': left operand must be l-value",  },
	{ "TVR1015", "'{name}': invalid variable type",  },
	{ "TVR1016", "'{name}': redefinition",  },
	{ "TVR1017", "integral type expected as an array size or index",  },
	{ "TVR1018", "'[]': index expected",  },
	{ "TVR1019", "'[]': array types do not support multiple indices",  },
	{ "TVR1020", "'{name}': integral type expected",  },
	{ "TVR1021", "'{name}': operand must be l-value",  },
	{ "TVR1022", "'{name}': illegal use of this type as an expression",  },
	{ "TVR1023", "'{op}': illegal operand type '{name}'",  },
	{ "TVR1024", "'{op}': illegal, '{name}' and '{name2}' are incompatible types",  },
	{ "TVR1025", "'{name}': type expected",  },
	{ "TVR1026", "'{name2}': left of '{name}' must have struct/auto/namespace type",  },
	{ "TVR1027", "'{name}': is not a member of the '{name2}'",  },
	{ "TVR1028", "'{name}': recursion found in value type member declaration",  },
	{ "TVR1029", "'{name}': global functions do not have 'this' pointers",  },
	{ "TVR1030", "'{name}': function not found",  },
	{ "TVR1031", "'{name}': illegal, only 'struct' types could be constructed in such way",  },
	{ "TVR1032", "'{name2}': '{name}' condition must have boolean type",  },
	{ "TVR1033", "'{name}': illegal statement",  },
	{ "TVR1034", "'goto': reference to unknown step '{name}'",  },
	{ "TVR1035", "'{name}': 'auto' or 'event' type expected for operator 'new'",  },
	{ "TVR1036", "'{name}': redefinition, function differs only by 'inout' or 'out' argument type",  },
	{ "TVR1037", "'{name}': redefinition, function differs only by result type '{name2}'",  },
	{ "TVR1038", "'[]': unexpected value in array type declaration",  },
	{ "TVR1039", "'{name}': invalid constructor name '{name2}'",  },
	{ "TVR1040", "'{name}': has too few parameters",  },
	{ "TVR1041", "'{name}': has too many parameters",  },
	{ "TVR1042", "'{name}': illegal, copy constructor should take 'inout' parameter, otherwise it causes infinite recursion",  },
	{ "TVR1043", "'{name}': entry point function not found",  },
	{ "TVR1044", "'{name}': invalid entry point function result type",  },
	{ "TVR1045", "'{name}': ambiguous call to overloaded function",  },
	{ "TVR1046", "'{name}': variable initialization is skipped by 'goto' statement",  },
	{ "TVR1047", "'{name}': illegal, implementation found for 'extern' function",  },
	{ "TVR1048", "'{name}': illegal, implementation could be skipped only for 'extern' functions",  },
	{ "TVR1049", "'{name}': more than one familiar attribute specified",  },
	{ "TVR1050", "'{name}': unable to call this method in a static context",  },
	{ "TVR1051", "'{name}': unknown character escape sequence",  },
	{ "TVR1052", "operator '=' could be declared only for 'struct' types",  },
	{ "TVR1053", "'{name}': invalid 'typeof' value type",  },
	{ "TVR1054", "'return': illegal statement in 'auto' method declaration",  },
	{ "TVR1055", "'{name}': recursion found in relax stack variable declaration",  },
	{ "TVR1056", "'{name}': invalid call of operator 'new' for static type",  },
	{ "TVR1057", "'{name}': illegal '{type}' declaration for event type",  },
	{ "TVR1058", "'{name}': event expected in send or post instruction",  },
	{ "TVR1059", "'{name}': invalid destination type in send or post instruction",  },
	{ "TVR1060", "'{name}': destination type does not support send or post instruction",  },
	{ "TVR1061", "'send': illegal, trying to send a synchronous event to itself",  },
	{ "TVR1062", "'post': illegal, trying to send an event to itself in a static context",  },
	{ "TVR1063", "'{name}': event expected in 'on' block declaration",  },
	{ "TVR1064", "'event': illegal, value out of 'on' block context",  },
	{ "TVR1065", "'{name}': event expected in 'out' action declaration",  },
	{ "TVR1066", "'{name}': illegal, 'out' subscribe list expected",  },
	{ "TVR1067", "'{name}': illegal, 'auto' type expected for subscriber list",  },
	{ "TVR_AMBIGUITY_INFO", "could be '{name}'",  },
	{ "TVR_GOTO_INFO", "see 'goto' statement",  },
	{ "TVR_SEEDECL_INFO", "see declaration of '{name}'",  },
};

/*************************************************************************/
/* GetMessage()                                                          */
/*                                                                       */
/*************************************************************************/
const MSG_HOLDER * TAVR_LOADER_GetMessage(const std::string & id)
{
	int index = ecg::FindMessage(id, TAVR_LOADER_messageTable, 72);
	if (index == -1) {
		return NULL;
	}
	return &TAVR_LOADER_messageTable[index];
}

/*************************************************************************/
/* GetMessageByIndex()                                                   */
/*                                                                       */
/*************************************************************************/
const MSG_HOLDER * TAVR_LOADER_GetMessageByIndex(int index)
{
	return &TAVR_LOADER_messageTable[index];
}

} // namespace ecg
