
/*************************************************************************/
/* LEX                                                               E13 */
/*                                                                       */
/* generated by ecg                                                      */
/*************************************************************************/

#ifndef TAVR_PROJECT_LOADER_LEX_H
#define TAVR_PROJECT_LOADER_LEX_H

#ifndef TOKEN_EOF
#define TOKEN_EOF		-1
#endif

#ifndef TOKEN_ERROR
#define TOKEN_ERROR		-2
#endif

namespace ecg {

class TAVR_PROJECT_LOADER_LEX {
public:
	enum TERMINALS {
		TOKEN_T_NAME_1,  // '{'
		TOKEN_T_NAME_2,  // '}'
		TOKEN_T_NAME_3,  // '='
		TOKEN_T_NAME_4,  // ';'
		TOKEN_T_STRING,  // '$string'
		TOKEN_T_LITERAL, // '$literal'
		TOKEN_T_CLINE,   // '$cline'
		TOKEN_T_CBEGIN,  // '$cbegin'
		TOKEN_T_CEND,    // '$cend'
	};

	enum {
		TOKEN_COMMENT_LINE			= TOKEN_T_CLINE,
		TOKEN_COMMENT_BLOCK_BEGIN	= TOKEN_T_CBEGIN,
		TOKEN_COMMENT_BLOCK_END		= TOKEN_T_CEND,
	};

	typedef unsigned char CHAR_T;

public:
	TAVR_PROJECT_LOADER_LEX(void);

	int					Token			(void) const { return token; }
	const std::string & TokenValue		(void) const { return value; }
	int					Line			(void) const { return line + 1; }
	int 				NextToken		(void);

	enum PRESET {
		PRESET_DEFAULT,
		PRESET_COMMENT,
	};

	void				SetPreset		(PRESET preset);
	void				PushPreset		(PRESET preset);
	void				PopPreset		(void);
	PRESET				GetPreset		(void) const;

protected:
	virtual void		Unexpected		(char ch);
	virtual void		Unexpected		(const std::string & val = std::string()); // empty string means end of file

private:
	bool				PopChar		(CHAR_T & ch);
	void				PushChar	(CHAR_T ch);

protected:
	int					token;
	std::string			value;
	int					line;

private:
	// enables unget any count of chars
	std::stack<CHAR_T>	charStack;

	// preset data
	std::stack<PRESET>	presetsStack;

	static const int 	isSkip_default[];
	static const int 	final_default[];
	static const int 	productive_default[];
	static const int 	isSkip_comment[];
	static const int 	final_comment[];
	static const int 	productive_comment[];

	// parsing data
	const int *			final;
	const int *			isSkip;
	const int *			productive;

	static const int	table[][12];
	static const int	terminal[];
};

} // namespace ecg

#endif // TAVR_PROJECT_LOADER_LEX_H
