/************************************************************
 * TAVR_RUNTIME_STRING.CPP                         24.10.2007
 *
 * .
 ************************************************************/

#include "tavr_runtime.hpp"

extern "C" {

/**************************************************************************
* __tavr_alloc_char_string()                                              *
*                                                                         *
**************************************************************************/
void * __tavr_alloc_char_string(char * buf __TAVR_MEM_STAT_INFO)
{
	int length = (int)strlen(buf) + 1;
	__tavr_int * res = (__tavr_int *)__tavr_alloc(2*sizeof(__tavr_int) + length*sizeof(__tavr_char), __tavr_ti_string __TAVR_MEM_STAT_VALUE);
	res[2] = length - 1;
	ECG_STATIC_ASSERT(__TAVR_ARRAY_OFFSET == 3);
	mbstowcs((wchar_t *)(res + __TAVR_ARRAY_OFFSET), buf, length);

	return res;
}

/**************************************************************************
* __tavr_alloc_string()                                                   *
*                                                                         *
**************************************************************************/
void * __tavr_alloc_string(__tavr_char * value __TAVR_MEM_STAT_INFO)
{
	int length = (int)wcslen((wchar_t *)value) + 1;
	__tavr_int * res = (__tavr_int *)__tavr_alloc(2*sizeof(__tavr_int) + length*sizeof(__tavr_char), __tavr_ti_string __TAVR_MEM_STAT_VALUE);
	res[2] = length - 1;
	wcscpy((wchar_t *)(res + __TAVR_ARRAY_OFFSET), (wchar_t *)value);

	return res;
}

/**************************************************************************
* __tavr__string___new()                                                  *
*                                                                         *
**************************************************************************/
void * __tavr__string___new(void)
{
	__tavr_int * res = (__tavr_int *)__tavr_alloc(2*sizeof(__tavr_int), __tavr_ti_string __TAVR_MEM_STAT_FILE_LINE);
	res[2] = 0;
	return res;
}

/*************************************************************************/
/* __tavr__string___destr_string()                                       */
/*                                                                       */
/*************************************************************************/
void __tavr__string___destr_string(__tavr_ref_t)
{
}

} // extern "C"

//
// End-of-file TAVR_RUNTIME_STRING.CPP
//
