/************************************************************
 * TAVR_RUNTIME_SYSTEM.CPP                         24.10.2007
 *
 * .
 ************************************************************/

#include "tavr_runtime.hpp"

#include <iostream>
#include <string>

#include <math.h>

#include <windows.h>
#include <mmsystem.h>

using namespace tavr;

extern "C" {

/**************************************************************************
* __tavr__System___readInt()                                              *
*                                                                         *
**************************************************************************/
int __tavr__System___readInt(void)
{
	int var;
	scanf("%d", &var);
	return var;
}

/**************************************************************************
* __tavr__System___readLine()                                             *
*                                                                         *
**************************************************************************/
__tavr_ref_t __tavr__System___readLine(void)
{
	std::string line;
	std::getline(std::cin, line);

	ECG_STATIC_ASSERT(sizeof(wchar_t) == sizeof(__tavr_char));

	__tavr_ref_t res;
	res.ref = (int *)__tavr_alloc_char_string((char *)line.c_str() __TAVR_MEM_STAT_FILE_LINE);
	res.ptr = res.ref + 1;

	return res;
}

/**************************************************************************
* __tavr__System___print___int()                                          *
*                                                                         *
**************************************************************************/
void __tavr__System___print___int(int var)
{
	printf("%d", var);
}

/**************************************************************************
* __tavr__System___println___int()                                        *
*                                                                         *
**************************************************************************/
void __tavr__System___println___int(int var)
{
	printf("%d\n", var);
}

/*************************************************************************/
/* __tavr__System___print___float()                                      */
/*                                                                       */
/*************************************************************************/
void __tavr__System___print___float(float var)
{
	printf("%f", var);
}

/*************************************************************************/
/* __tavr__System___println___float()                                    */
/*                                                                       */
/*************************************************************************/
void __tavr__System___println___float(float var)
{
	printf("%f\n", var);
}

/*************************************************************************/
/* __tavr__System___print___double()                                     */
/*                                                                       */
/*************************************************************************/
void __tavr__System___print___double(double var)
{
	printf("%f", var);
}

/*************************************************************************/
/* __tavr__System___println___double()                                   */
/*                                                                       */
/*************************************************************************/
void __tavr__System___println___double(double var)
{
	printf("%f\n", var);
}

/**************************************************************************
* __tavr__System___print___char()                                         *
*                                                                         *
**************************************************************************/
void __tavr__System___print___char(__tavr_char ch)
{
	wprintf(L"%c", ch);
}

/**************************************************************************
* __tavr__System___print___string()                                       *
*                                                                         *
**************************************************************************/
void __tavr__System___print___string(__tavr_ref_t str_)
{
	if (str_.ref == NULL) {
		printf("null");
		return ;
	}

	REF_STRING str = str_.ref;

	char buf[1024];
	__TAVR_ASSERT(str->length < 1024, "Internal error");

	wcstombs(buf, str->value, str->length);
	buf[str->length] = 0;

	printf("%s", buf);
}

/**************************************************************************
* __tavr__System___println___string()                                     *
*                                                                         *
**************************************************************************/
void __tavr__System___println___string(__tavr_ref_t str_)
{
	if (str_.ref == NULL) {
		printf("null\n");
		return ;
	}

	REF_STRING str = str_.ref;

	char buf[1024];
	__TAVR_ASSERT(str->length < 1024, "Internal error");

	wcstombs(buf, str->value, str->length);
	buf[str->length] = 0;

	printf("%s\n", buf);
}

/************************************************************************/
/* __tavr__System___println___string
/*
/************************************************************************/
__tavr_int __tavr__System___getRefCount___null(__tavr_ref_t ptr_)
{
	if (ptr_.ref == NULL) {
		return 0;
	}

	REF<void> ptr = ptr_.ref;
	return ptr.refcount() - 1;
}

/*************************************************************************/
/* __tavr__System___getTime()                                            */
/*                                                                       */
/*************************************************************************/
int __tavr__System___getTime(void)
{
	return (int)timeGetTime();
}

/*************************************************************************/
/* __tavr__System___getTime2()                                           */
/*                                                                       */
/*************************************************************************/
double __tavr__System___getTime2(void)
{
	LARGE_INTEGER cur;
	QueryPerformanceCounter(&cur);
	LARGE_INTEGER freq;
	QueryPerformanceFrequency(&freq);

	return 1000.0 * (double)cur.QuadPart / (double)freq.QuadPart;
}

/*************************************************************************/
/* __tavr__System___random()                                             */
/*                                                                       */
/*************************************************************************/
float __tavr__random(void)
{
	return (float)rand() / (float)RAND_MAX;
}

/*************************************************************************/
/* __tavr__System___sqrt___float()                                       */
/*                                                                       */
/*************************************************************************/
float __tavr__sqrt___float(float val)
{
	return sqrt(val);
}

/*************************************************************************/
/* __tavr__System___sqrt___double()                                      */
/*                                                                       */
/*************************************************************************/
double __tavr__sqrt___double(double val)
{
	return sqrt(val);
}

/*************************************************************************/
/* __tavr__System___debugBreak()                                         */
/*                                                                       */
/*************************************************************************/
void __tavr__System___debugBreak(void)
{
	DebugBreak();
}

} // extern "C"

//
// End-of-file TAVR_RUNTIME_SYSTEM.CPP
//
